registerGameMode("Team Deathmatch","TDM",1,0,0);
setGameModeHelp("Team Deathmatch","Add-Ons/Gamemode_TeamDeathmatch/rules_tdm.txt");
addGameModeRule("Team Deathmatch","Time","int 0 30",0);
addGameModeRule("Team Deathmatch","Lives","int 0 10",0);
addGameModeRule("Team Deathmatch","Points","int 0 10000",0);

//For an explanation of when these functions are used, see Gamemode_EXAMPLE.cs

function GameMode_TDM_onModeUpdateRule0(%mini,%rulevalue,%oldvalue,%modestart)
{
	//Reset the minigame to update limits
	return 1;
}

function GameMode_TDM_onModeUpdateRule1(%mini,%rulevalue,%oldvalue,%modestart)
{
	//Reset the minigame to update limits
	return 1;
}

function GameMode_TDM_onModeUpdateRule2(%mini,%rulevalue,%oldvalue,%modestart)
{
	//Reset the minigame to update limits
	return 1;
}

function GameMode_TDM_onMiniReset(%mini,%client)
{
	if(%mini.tdmModeRule[0] != 0)
		%mini.messageAll('',"\c5This round lasts \c3" @ %mini.tdmModeRule[0] @ "\c5 minute" @ (%mini.tdmModeRule[0] == 1 ? "" : "s") @ ".");
	
	if(%mini.tdmModeRule[1] != 0)
		%mini.messageAll('',"\c5You have \c3" @ %mini.tdmModeRule[1] @ "\c5 " @ (%mini.tdmModeRule[1] == 1 ? "life" : "lives") @ " remaining.");
	
	if(%mini.tdmModeRule[2] != 0)
		%mini.messageAll('',"\c5The first team to reach \c3" @ %mini.tdmModeRule[2] @ "\c5 point" @ (%mini.tdmModeRule[2] == 1 ? "" : "s") @ " wins.");
	
	%mini.setTimeLimit(%mini.tdmModeRule[0]);
	%mini.setLivesLimit(%mini.tdmModeRule[1]);
	%mini.setPointsLimit(%mini.tdmModeRule[2]);
}

function GameMode_TDM_onTimeLimit(%mini)
{
	//Edited version of Minigame::roundEnd to find the highest scores and make those people win
	//Both teams and players in no team can win the round
	
	if(%mini.roundWon)
		return;
	
	%highestScore = %mini.member0.score;
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];      
		if(%cl.score $= "")
			%cl.score = 0;
		if(%mini.teamExists[%cl.tdmTeam] && %cl.tdmTeam != -1)
		{
			%score[%cl.tdmTeam] += %mini.member[%i].score;
		}
		else if(%cl.score > %highestScore)
		{
			%highestScore = %cl.score;
		}
	}
	
	for(%i=0;%i<6;%i++)
	{
		if(%score[%i] $= "")
			%score[%i] = 0;
		if(%mini.teamExists[%i] && %score[%i] > %highestScore)
		{
			%highestScore = %score[%i];
		}
	}
	
	%winCount = -1;
	
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
		{
			if(%score[%i] == %highestScore)
			{
				%wins[%winCount++] = teamName(%mini,%i);
			}
		}
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(%cl.tdmTeam == -1)
		{
			if(%cl.score == %highestScore)
			{
				%wins[%winCount++] = "\c3" @ %cl.getPlayerName();
				if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
					%cl.player.emote(winStarProjectile,1);
				%cl.tdmRoundsWon++;
				%cl.play2d(rewardSound);
			}
		}
		else if(%score[%cl.tdmTeam] == %highestScore)
		{
			if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
				%cl.player.emote(winStarProjectile,1);
			%cl.tdmRoundsWon++;
			%cl.play2d(rewardSound);
		}
	}
	
	//%winCount cannot be zero as long as there is a player in the minigame
	//which there should be unless you're hacking it to bits for a dedicated
	//even so, the message won't actually be displayed to anyone if that's the case so it should be okay
	%msg = %wins[0];
	if(%winCount > 0)
	{
		for(%i=1;%i<%winCount;%i++)
		%msg = %msg @ "\c5, " @ %wins[%i];
		%msg = %msg @ "\c5 and " @ %wins[%winCount];
	}
	%msg = %msg @ "\c5 won this round with \c3" @ %highestScore @ "\c5 point" @ (%highestScore == 1 ? "" : "s") @ ". Resetting in five seconds...";
	%mini.messageAll('',%msg);
	
	%mini.roundWon = 1;
	%mini.roundSwapTeams = 0;
	
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(isObject(%cl.player))
		{
			%cl.setControlObject(%cl.camera);
			%cl.camera.setMode("Corpse",%cl.player);
			%cl.tdmCameraTarget = 0;
		}
		else
		{
			%cl.getAutoCameraTarget();
		}
	}
	
	%mini.schedule(5000,reset,%mini.owner);
}
