//Game Mode Storer and helper functions
if(!isObject(GameModeStorerSO))
	new ScriptObject(GameModeStorerSO){modeCount=-1;};
schedule(1,0,initGameModes);

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Echo Team/Dead Chat","Team Deathmatch","SpaceMods::Server::TeamDM::EchoChat","bool","Gamemode_TeamDeathmatch",0,0,0);
}
else
{
   $SpaceMods::Server::TeamDM::EchoChat = 0;
}

function initGameModes()
{
	//UI name tables are clientside
	if($SpaceMods::Server::uiTablesCreated)
		return; 
	
	for(%i=0;%i<DatablockGroup.getCount();%i++)
	{
		%o = DatablockGroup.getObject(%i);
		if(%o.getClassName() $= "PlayerData" && %o.uiName !$= "")
		{
			$serveruiNameTable_Players[%o.uiName] = %o.getID();
		}
		else if(%o.getClassName() $= "ItemData" && %o.uiName !$= "")
		{
			$serveruiNameTable_Items[%o.uiName] = %o.getID();
		}
		else if(%o.getClassName() $= "ParticleEmitterData" && %o.uiName !$= "")
		{
			$serveruiNameTable_Emitters[%o.uiName] = %o.getID();
		}
		else if(%o.getClassName() $= "fxLightData" && %o.uiName !$= "")
		{
			$serveruiNameTable_Lights[%o.uiName] = %o.getID();
		}
		else if(%o.getClassName() $= "AudioProfile" && %o.uiName !$= "")
		{
			$serveruiNameTable_Music[%o.uiName] = %o.getID();
		}
		else if(%o.getClassName() $= "fxDTSBrickData" && %o.uiName !$= "")
		{
			$serveruiNameTable_Bricks[%o.uiName] = %o.getID();
		}
	}
	
	//some v8 mods created extra standard players, this is just to be safe
	$serveruiNameTable_Players["Standard Player"] = playerStandardArmor.getID();
	
	$SpaceMods::Server::uiTablesCreated = 1;
}

function registerGameMode(%title,%short,%usesTeams,%specialTeams,%usesRounds)
{
	if(GameModeStorerSO.modeID[%title] !$= "")
		return;
	
	GameModeStorerSO.modeCount++;
	GameModeStorerSO.modeID[%title] = GameModeStorerSO.modeCount;			//ID of the mode from its title, used for gameModeTitleToID
	GameModeStorerSO.modeTitle[GameModeStorerSO.modeCount] = %title;		//Title of game mode (e.g. "Team Deathmatch")
	GameModeStorerSO.modeShortTitle[GameModeStorerSO.modeCount] = %short;		//Short acronym/abbreviation used for functions (e.g. "TDM", "CR", "CTF")
	GameModeStorerSO.modeUsesTeams[GameModeStorerSO.modeCount] = %usesTeams;	//Does the mode use team functions?
	GameModeStorerSO.modeSpecialTeams[GameModeStorerSO.modeCount] = %specialTeams;	//Does the mode need special team settings? (e.g. Cops and Robbers)
	GameModeStorerSO.modeUsesRounds[GameModeStorerSO.modeCount] = %usesRounds;	//Only display 'Rounds Won' in the Scores update
	GameModeStorerSO.modeRuleCount[GameModeStorerSO.modeCount] = 0;			//Number of rules for the game mode
}

function addGameModeRule(%title,%text,%rule,%default)
{
	if(GameModeStorerSO.modeID[%title] $= "")
		return;
	
	%id = GameModeStorerSO.modeID[%title];
	
	for(%i=0;%i<GameModeStorerSO.modeRuleCount[%id];%i++)
	{
		if(GameModeStorerSO.modeRuleTxt[%id,%i] $= %text)
			return;
	}
	
	GameModeStorerSO.modeRuleTxt[%id,GameModeStorerSO.modeRuleCount[%id]] = %text;		//Text to display
	GameModeStorerSO.modeRuleStr[%id,GameModeStorerSO.modeRuleCount[%id]] = %rule;		//Rule value definition
	GameModeStorerSO.modeRuleDef[%id,GameModeStorerSO.modeRuleCount[%id]] = %default;	//Default value
	GameModeStorerSO.modeRuleCount[%id]++;
}

function addGeneralRule(%title,%text,%rule,%default)
{
	%id = -1;
	if(GameModeStorerSO.modeRuleCount[%id] $= "")
		GameModeStorerSO.modeRuleCount[%id] = 0;
	
	for(%i=0;%i<GameModeStorerSO.modeRuleCount[%id];%i++)
	{
		if(GameModeStorerSO.modeRuleTxt[%id,%i] $= %text)
			return;
	}
	
	GameModeStorerSO.modeRuleTxt[%id,GameModeStorerSO.modeRuleCount[%id]] = %text;		//Text to display
	GameModeStorerSO.modeRuleStr[%id,GameModeStorerSO.modeRuleCount[%id]] = %rule;		//Rule value definition
	GameModeStorerSO.modeRuleDef[%id,GameModeStorerSO.modeRuleCount[%id]] = %default;	//Default value
	GameModeStorerSO.modeRuleTitle[%id,GameModeStorerSO.modeRuleCount[%id]] = %title;	//Name of function TeamDeathmatch_onUpdateGeneralRule_[Title]
	GameModeStorerSO.modeRuleCount[%id]++;
}

function setGameModeHelp(%title,%file)
{
	if(GameModeStorerSO.modeID[%title] $= "")
		return;
	
	%id = GameModeStorerSO.modeID[%title];
	
	if(!isFile(%file))
	{
		echo("::setGameModeHelp(): The file does not exist. (" @ %file @ ")");
		return;
	}
	
	%f = new FileObject();
	%f.openForRead(%file);
	
	%line = %f.readLine();
	
	while(%line !$= "")
	{
		%text = (%text $= "" ? %line : %text NL %line);
		%line = %f.readLine();
	}
	
	%f.close();
	%f.delete();
	
	GameModeStorerSO.modeHelp[%id] = %text;
}

function gameModeTitleExists(%title) //e.g. gameModeTitleExists("Deathmatch")
{
	if(GameModeStorerSO.modeID[%title] $= "")
		return 0;
	else
		return 1;
}

function gameModeIDExists(%id)
{
	return (%id > -1 && %id <= GameModeStorerSO.modeCount);
}

function gameModeTitleToID(%title) //e.g. gameModeTitleToID("Deathmatch")
{
	if(GameModeStorerSO.modeID[%title] $= "")
		return -1;
	else
		return GameModeStorerSO.modeID[%title];
}

function gameModeIDToTitle(%id)
{
	return gameModeAttribute(%id,"Title");
}

function gameModeAttribute(%id,%a) //e.g. gameModeAttribute(%mini.gamemode,"UsesTeams")
{
	return (GameModeStorerSO.mode[%a @ %id]);
}

//This is quite useful. Fixed according to Trader's suggestions.
function isInt(%string)
{
	return %string $= mFloatLength(%string, 0);
}

//Fixes a colour's values to two decimal places and (optionally) strips alpha value
function fixAvatarColor(%col,%alpha)
{
	if(%alpha)
		return mFloatLength(getWord(%col,0),2) SPC mFloatLength(getWord(%col,1),2) SPC mFloatLength(getWord(%col,2),2) SPC mFloatLength(getWord(%col,3),2);
	else
		return mFloatLength(getWord(%col,0),2) SPC mFloatLength(getWord(%col,1),2) SPC mFloatLength(getWord(%col,2),2) SPC 1;
}

//Find closest color ID to a certain value
function getClosestPaintColor(%rgba)
{
	%prevdist = 100000;
	%colorMatch = 0;
	for(%i = 0;%i < 64;%i++)
	{
		%color = getColorIDTable(%i);
		if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist && getWord(%rgba,3) - getWord(%color,3) < 0.3 && getWord(%rgba,3) - getWord(%color,3) > -0.3)
		{
			%prevdist = vectorDist(%rgba,%color);
			%colormatch = %i;
		}
	}
	return %colormatch;
}

//Get the position of the Base of a spawn point from its transform or the top of the brick for others
function fxDTSBrick::getSpawnTransform(%this)
{
	%trans = %this.getTransform();
	%pos = posFromTransform(%trans);
	%rot = rotFromTransform(%trans);
	
	if(fileName(%this.dataBlock.brickfile) $= "spawnPoint.blb")
		%pos = vectorSub(%pos,"0 0 1.25");
	else
		%pos = vectorAdd(%pos,"0 0 " @ %this.dataBlock.brickSizeZ*0.1);
	
	return %pos SPC %rot;
}

//Server Commands
function servercmdSetGameModeData(%client,%i,%data)
{
	if(!isInt(%i))
		return;
	
	%client.gameModeData[%i] = %data;
	%client.gameModeData[%i+1] = ""; //makes sure that this is 'last' processed
}

function servercmdProcessGameModeData(%client)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	if(!isObject(%client.minigame))
		return;
	if(%client.minigame.owner != %client)
		return;
	
	for(%i=0;%client.gameModeData[%i]!$="";%i++)
	{
		%dataString = (%dataString $= "" ? %client.gameModeData[%i] : %dataString TAB %client.gameModeData[%i]);
		%client.gameModeData[%i] = "";
	}
	
	%mini = %client.minigame;
	
	//First time set
	if(%mini.gameTeamChat $= "")
		%mini.gameTeamChat = 1;
	
	for(%i=0;(%str=getField(%datastring,%i))!$="";%i++)
	{
		switch$(getWord(%str,0))
		{
			case "MOD":
				%id = gameModeTitleToID(getWords(%str,1));
				if(!gameModeIDExists(%id))
					continue;
				if(%mini.gamemode != %id || %mini.gamemode $= "")
				{
					%changedMode = 1;
					
					%mini.setTimeLimit(0);
					%mini.setLivesLimit(0);
					%mini.setPointsLimit(0);
					%mini.resetCapturePoints();
					
					%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onModeEnd";
					if(isFunction(%f))
						call(%f,%mini);
					
					if(!gameModeAttribute(%id,"UsesTeams"))
					{
						for(%a=0;%a<6;%a++)
						{
							%mini.teamExists[%a] = 0;
							%mini.teamCol[%a] = "";
							%mini.teamName[%a] = "";
							%mini.teamUniform[%a] = "";
							%mini.leadUniform[%a] = "";
							%mini.teamAutoSortRatio[%a] = "";
							
							cancel(%mini.swapSched[%a]);
							%mini.swapTeam[%a] = "";
							%mini.swapSched[%a] = "";
						}
						for(%j=0;%j<%mini.numMembers;%j++)
						{
							%cl = %mini.member[%j];
							%cl.tdmRoundsWon = 0;
							if(%cl.tdmTeam != -1)
							{
								%cl.tdmTeam = -1;
								%respawn[%cl] = 1;
							}
						}
					}
					if(%mini.gamemode $= "" && gameModeIDToTitle(%id) $= "Deathmatch")
						%noStartMessage = 1;
					%mini.gamemode = %id;
					%mini.sortMemberOffset = 0;
				}
				
			case "TEXIST":
				%a = getWord(%str,1);
				%b = getWord(%str,2);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(%mini.teamExists[%a] != %b)
					%changedTeams = 1;
				%mini.teamExists[%a] = %b;
				if(%b)
				{
					if(%client.tdmStoreUniform[%a] !$= %mini.teamUniform[%a])
					{
						%mini.teamUniform[%a] = %client.tdmStoreUniform[%a];
						if(%mini.teamUniform[%a] !$= "")
						{
							for(%j=0;%j<%mini.numMembers;%j++)
							{
								%cl = %mini.member[%j];
								if(%cl.tdmTeam == %a && %mini.teamLeader[%a] != %cl && isObject(%cl.player))
									applyCharacterPrefs(%cl);
							}
						}
					}
					if(%client.tdmStoreLUniform[%a] !$= %mini.leadUniform[%a])
					{
						%mini.leadUniform[%a] = %client.tdmStoreLUniform[%a];
						if(%mini.leadUniform[%a] !$= "")
						{
							for(%j=0;%j<%mini.numMembers;%j++)
							{
								%cl = %mini.member[%j];
								if(%cl.tdmTeam == %a && %mini.teamLeader[%a] == %cl && isObject(%cl.player))
									applyCharacterPrefs(%cl);
							}
						}
					}
					%client.tdmStoreUniform[%a] = "";
					%client.tdmStoreLUniform[%a] = "";
					%mini.teamAutoSortRatio[%a] = 1;
				}
				else
				{
					%mini.teamName[%a] = "";
					%mini.teamCol[%a] = "";
					%mini.teamUniform[%a] = "";
					%mini.leadUniform[%a] = "";
					%mini.teamAutoSortRatio[%a] = "";
					cancel(%mini.swapSched[%a]);
					%mini.swapTeam[%a] = "";
					%mini.swapSched[%a] = "";
					for(%j=0;%j<%mini.numMembers;%j++)
					{
						%cl = %mini.member[%j];
						if(%cl.tdmTeam == %a)
						{
							%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
							if(isFunction(%f))
								call(%f,%mini,%cl,%a,-1);
							%cl.tdmTeam = -1;
							%respawn[%cl] = 1;
						}
					}
				}
				
			case "TNAME":
				%a = getWord(%str,1);
				%b = getWords(%str,2);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(!%mini.teamExists[%a])
					continue;
				
				%temp = stripMLControlChars(%b);
				while(%temp !$= %b)
				{
					%b = %temp;
					%temp = stripMLControlChars(%b);
				}
				
				%b = trim(%b);
				if(%b $= "")
					continue;
				if(%mini.teamName[%a] !$= %b)
					%changedTeams = 1;
				%mini.teamName[%a] = %b;
				
			case "TCOL":
				%a = getWord(%str,1);
				%b = getWords(%str,2);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(!%mini.teamExists[%a])
					continue;
				if(%b < 0 || %b > 64)
					continue;
				if(%mini.teamCol[%a] != %b)
					%changedTeams = 1;
				%mini.teamCol[%a] = %b;
				
				if(%mini.teamUniform[%a] $= "")
				{
					%col = getWords(getColorIDTable(%mini.teamCol[%a]),0,2) SPC 1;
					%mini.teamUniform[%a] = 0 TAB %col TAB
					0 TAB %col TAB
					0 TAB %col TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB %col TAB
					0 TAB %col TAB
					1 TAB %col TAB
					1 TAB "0 0.2 0.64 0.7" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.9 0.9 0.0 1" TAB
					"1 0.878 0.611 1" TAB
					"AAA-None" TAB "smileyCreepy";
					for(%j=0;%j<%mini.numMembers;%j++)
					{
						%cl = %mini.member[%j];
						if(%cl.tdmTeam == %a && %mini.teamLeader[%a] != %cl && isObject(%cl.player))
							applyCharacterPrefs(%cl);
					}
				}
				if(%mini.leadUniform[%a] $= "")
				{
					%mini.leadUniform[%a] = 0 TAB %col TAB
					0 TAB %col TAB
					0 TAB %col TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB "0.2 0.2 0.2 1" TAB
					0 TAB %col TAB
					0 TAB %col TAB
					6 TAB %col TAB
					0 TAB "0 0.2 0.64 0.7" TAB
					0 TAB "1 1 0 1" TAB
					2 TAB "1 1 0 1" TAB
					"1 0.878 0.611 1" TAB
					"AAA-None" TAB "smileyCreepy";
					for(%j=0;%j<%mini.numMembers;%j++)
					{
						%cl = %mini.member[%j];
						if(%cl.tdmTeam == %a && %mini.teamLeader[%a] == %cl && isObject(%cl.player))
							applyCharacterPrefs(%cl);
					}
				}
				
			case "TSE":
				%a = getWord(%str,1);
				%b = getWord(%str,2);
				%c = getWord(%str,3);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(!%mini.teamExists[%a])
					continue;
				if(%b < 0 || %b > 4)
					continue;
				if(!isInt(%b))
					continue;
				if(!isObject(%c))
					%c = 0;
				else if(%c.getClassName() !$= "ItemData")
					%c = 0;
				if(%c == %mini.teamStartEquip[%a,%b])
					continue;
				%mini.teamStartEquip[%a,%b] = %c;
				for(%j=0;%j<%mini.numMembers;%j++)
				{
					%cl = %mini.member[%j];
					if(%cl.tdmTeam == %a && isObject(%cl.player) && %mini.teamLeader[%a] != %cl)
					{
						%cl.player.tool[%b] = %c;
						messageClient(%cl,'MsgItemPickup',"",%b,%c,1);
						if(%cl.player.currTool == %b)
						{
							if(%cl.player.tool[%b] == 0)
								servercmdUnUseTool(%cl);
							else
								servercmdUseTool(%cl,%b);
						}
					}
				}
				
			case "TLSE":
				%a = getWord(%str,1);
				%b = getWord(%str,2);
				%c = getWord(%str,3);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(!%mini.teamExists[%a])
					continue;
				if(%b < 0 || %b > 4)
					continue;
				if(!isInt(%b))
					continue;
				if(!isObject(%c))
					%c = 0;
				else if(%c.getClassName() !$= "ItemData")
					%c = 0;
				if(%c == %mini.leadStartEquip[%a,%b])
					continue;
				%mini.leadStartEquip[%a,%b] = %c;
				%cl = %mini.teamLeader[%a];
				if(isObject(%cl) && isObject(%cl.player) && %cl.tdmTeam == %a)
				{
					%cl.player.tool[%b] = %c;
					messageClient(%cl,'MsgItemPickup',"",%b,%c,1);
					if(%cl.player.currTool == %b)
					{
						if(%cl.player.tool[%b] == 0)
							servercmdUnUseTool(%cl);
						else
							servercmdUseTool(%cl,%b);
					}
				}
				
			case "TDB":
				%a = getWord(%str,1);
				%b = getWord(%str,2);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(!%mini.teamExists[%a])
					continue;
				if(!isObject(%b))
					%b = playerStandardArmor.getID();
				else if(%b.getClassName() !$= "PlayerData")
					%b = playerStandardArmor.getID();
				else if(%b.uiName $= "Standard Player")
					%b = playerStandardArmor.getID(); //Bushido failed at player types
				if(%b == %mini.teamPlayerData[%a])
					continue;
				%mini.teamPlayerData[%a] = %b;
				for(%j=0;%j<%mini.numMembers;%j++)
				{
					%cl = %mini.member[%j];
					if(%cl.tdmTeam == %a && isObject(%cl.player) && %mini.teamLeader[%a] != %cl && isObject(%cl.player) && %cl.player.dataBlock.getID() != %b.getID())
						%cl.player.setDatablock(%b);
				}
				
			case "TLDB":
				%a = getWord(%str,1);
				%b = getWord(%str,2);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(!%mini.teamExists[%a])
					continue;
				if(!isObject(%b))
					%b = playerStandardArmor.getID();
				else if(%b.getClassName() !$= "PlayerData")
					%b = playerStandardArmor.getID();
				else if(%b.uiName $= "Standard Player")
					%b = playerStandardArmor.getID(); //Bushido failed at player types
				if(%b == %mini.leadPlayerData[%a])
					continue;
				%mini.leadPlayerData[%a] = %b;
				%cl = %mini.teamLeader[%a];
				if(isObject(%cl) && isObject(%cl.player) && %cl.tdmTeam == %a && isObject(%cl.player) && %cl.player.dataBlock.getID() != %b.getID())
					%cl.player.setDatablock(%b);
				
			case "TASR":
				%a = getWord(%str,1);
				%b = getWord(%str,2);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 5)
					continue;
				if(!isInt(%a))
					continue;
				if(!%mini.teamExists[%a])
					continue;
				%mini.teamAutoSortRatio[%a] = %b;
				
			case "UNIMODE":
				%a = getWord(%str,1); 
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a < 0 || %a > 3)
					continue;
				if(!isInt(%a))
					continue;
				if(%mini.uniMode == %a)
					continue;
				%mini.uniMode = %a;
				for(%j=0;%j<%mini.numMembers;%j++)
				{
					%cl = %mini.member[%j];
					if(%cl.tdmTeam != -1 && isObject(%cl.player))
					{
						applyCharacterPrefs(%cl);
					}
				}
				
			case "FF":
				%a = getWord(%str,1);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a && !%mini.gameFriendlyFire)
				{
					%mini.gameFriendlyFire = 1;
					%mini.messageAll('',"\c3Friendly Fire\c5 is now \c2on\c5.");
				}
				else if(!%a && %mini.gameFriendlyFire)
				{
					%mini.gameFriendlyFire = 0;
					%mini.messageAll('',"\c3Friendly Fire\c5 is now \c0off\c5.");
				}
				
			case "PTK":
				%a = getWord(%str,1);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				%mini.Points_TeamKill = (%a+0); //changes to 'real' number e.g. "asdf"+0 = 0
				
			case "TC":
				%a = getWord(%str,1);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a && !%mini.gameTeamChat)
				{
					%mini.gameTeamChat = 1;
					%mini.messageAll('',"\c3Team Chat\c5 is now \c2on\c5.");
				}
				else if(!%a && %mini.gameTeamChat)
				{
					%mini.gameTeamChat = 0;
					%mini.messageAll('',"\c3Team Chat\c5 is now \c0off\c5.");
				}
				
			case "AS":
				%a = getWord(%str,1);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%a == 0 && %mini.gameAutoSort != 0)
				{
					%mini.gameAutoSort = 0;
					%mini.messageAll('',"\c3Auto Sort\c5 is now \c0off\c5.");
				}
				else if(%a == 1 && %mini.gameAutoSort != 1)
				{
					%mini.gameAutoSort = 1;
					%mini.messageAll('',"\c3Auto Sort\c5 is now \c3on\c5. (\c3Sort\c5)");
					
					if(!%mini.gameTeamsLock)
					{
						%mini.gameTeamsLock = 1;
						%mini.messageAll('',"\c5Teams are now \c0locked\c5.");
					}
					
					for(%j=0;%j<%mini.numMembers;%j++)
					{
						%c = %mini.member[%j];
						if(%c.tdmTeam == -1)
						{
							%team = %mini.pickAutoSortTeam();
							if(%team != -1)
							{
								%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
								if(isFunction(%f))
									call(%f,%mini,%c,%c.tdmTeam,%team);
								%c.tdmTeam = %team;
								%respawn[%cl] = 1;
								%mini.messageAll('',"\c3" @ %c.getPlayerName() @ "\c5 was put into " @ teamName(%mini,%c.tdmTeam) @ "\c5. (Auto Sort)");
							}
						}
					}
					
				}
				else if(%a == 2 && %mini.gameAutoSort != 2)
				{
					%mini.gameAutoSort = 2;
					%mini.messageAll('',"\c3Auto Sort\c5 is now \c3on\c5. (\c3Fix\c5)");
					
					if(!%mini.gameTeamsLock)
					{
						%mini.gameTeamsLock = 1;
						%mini.messageAll('',"\c5Teams are now \c0locked\c5.");
					}
				}
				
			case "TL":
				%a = getWord(%str,1);
				if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
					continue;
				if(%mini.gameAutoSort != 0)
					continue;
				if(%a && !%mini.gameTeamsLock)
				{
					%mini.gameTeamsLock = 1;
					%mini.messageAll('',"\c5Teams are now \c0locked\c5.");
				}
				else if(!%a && %mini.gameTeamsLock)
				{
					%mini.gameTeamsLock = 0;
					%mini.messageAll('',"\c5Teams are now \c2unlocked\c5.");
				}
				
			case "H":
				%mini.tdmHelpShow = getWord(%str,1);
				
			case "HN":
				%mini.tdmHideNames = getWord(%str,1);
				for(%j=0;%j<%mini.numMembers;%j++)
				{
					%cl = %mini.member[%j];
					if(isObject(%cl.player))
					{
						//Reset shape names to minigame/game mode settings
						%cl.player.setShapeNameDistance(600);
					}
				}
		}
	}
	
	if(%changedMode && !%noStartMessage)
	{
		%mini.messageAll('',"\c5The minigame is now running \c3" @ gameModeIDToTitle(%mini.gameMode) @"\c5.");
	}
	
	if(%changedTeams)
	{
		%mini.fixTeamOrder();
		%mini.messageAll('',"\c5The list of teams has been updated:");
		for(%i=0;%i<6;%i++)
		{
			if(%mini.teamExists[%i])
			{
				%mini.messageAll('',teamName(%mini,%i));
			}
		}
		if(!%mini.teamExists[0])
		{
			%mini.messageAll('',"\c5No teams exist.");
		}
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%c = %mini.member[%i];
		if(!%mini.teamExists[%c.tdmTeam])
		{
			%c.tdmTeam = -1;
		}
	}
	
	if(%mini.gameAutoSort == 2)
		%mini.sortMemberTeams("(Auto Sort)");
	
	%count = GameModeStorerSO.modeRuleCount[%mini.gamemode]+GameModeStorerSO.modeRuleCount[-1];
	for(%i=0;%i<%count;%i++)
	{
		if(%i >= GameModeStorerSO.modeRuleCount[%mini.gamemode])
		{
			%ind = %i - GameModeStorerSO.modeRuleCount[%mini.gamemode];
			if(%client.modeGeneralRule[%ind] $= "")
				continue;
			
			%r = %client.modeGeneralRule[%ind];
			%client.modeGeneralRule[%ind] = "";
			
			%str = GameModeStorerSO.modeRuleStr[-1,%ind];
			%def = GameModeStorerSO.modeRuleDef[-1,%ind];
			%title = GameModeStorerSO.modeRuleTitle[-1,%ind];
			%mode = -1;
		}
		else
		{
			if(%client.modeRule[%i] $= "")
				continue;
			
			%r = %client.modeRule[%i];
			%client.modeRule[%i] = "";
			
			%str = GameModeStorerSO.modeRuleStr[%mini.gamemode,%i];
			%def = GameModeStorerSO.modeRuleDef[%mini.gamemode,%i];
			%mode = %mini.gamemode;
		}
		
		switch$(firstWord(%str))
		{
			case "bool":
				if(%r != 1 && %r != 0)
					%r = %def;
				
			case "list":
				%ok=0;
				if(strPos(%str,"\t") == -1)
				{
					for(%j=2;%j<getWordCount(%str);%j+=2)
					{
						if(%r $= getWord(%str,%j))
						{
							%ok=1;
						}
					}
				}
				else
				{
					for(%j=2;%j<getFieldCount(%str);%j+=2)
					{
						if(%r $= getField(%str,%j))
						{
							%ok=1;
						}
					}
				}
				if(!%ok)
					%r = %def;
				
			case "dataBlock":
				%r = getField(%r,0);
				if(isObject(%r))
					switch$(getWord(%str,1))
				{
					case "Music":
						if(%r.uiName $= "" || %r.getClassName() !$= "AudioProfile" || !%r.description.isLooping)
							%r = 0;
						
					case "Vehicle":
						%class = %r.getClassName();
						if(%r.uiName $= "" || !((%r.rideable && %class $= "PlayerData") || %class $= "WheeledVehicleData" || %class $= "FlyingWheeledVehicleData" || %class $= "FlyingVehicleData"))
							%r = 0;
						
					case "Sound":
						if(%r.getClassName() !$= "AudioProfile" || %r.description.isLooping)
							%r = 0;
						
						default:
						if(%r.uiName $= "" || %r.getClassName() !$= getWord(%str,1))
							%r = 0;
				}
				else
					%r = 0;
				
			case "int":
				%r = mClampF(%r,getWord(%str,1),getWord(%str,2));
				if(!isInt(%r))
					%r = %def;
				
			case "string":
				%r = getSubStr(%r,0,getWord(%str,1));
		}
		
		if(%i >= GameModeStorerSO.modeRuleCount[%mini.gamemode])
		{
			if(%r != %mini.tdmGeneralRule_[%title] || %changedMode)
			{
				%old = %mini.tdmGeneralRule_[%title];
				%mini.tdmGeneralRule_[%title] = %r;
				
				%f = "TeamDeathmatch_onUpdateGeneralRule_" @ %title;
				if(isFunction(%f))
				{
					%check = call(%f,%mini,%r,%old,%changedMode);
					if(%check)
						%reset = 1;
				}
			}
		}
		else
		{
			if(%r != %mini.tdmModeRule[%i] || %changedMode)
			{
				%old = %mini.tdmModeRule[%i];
				%mini.tdmModeRule[%i] = %r;
				
				%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onModeUpdateRule" @ %i;
				if(isFunction(%f))
				{
					%check = call(%f,%mini,%r,%old,%changedMode);
					if(%check)
						%reset = 1;
				}
			}
		}
	}
	
	if(%reset)
		%mini.reset(%client);
	
	if(%changedMode)
	{
		if(!%noStartMessage && !%reset)
			%mini.reset(%client);
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onModeStart";
		if(isFunction(%f))
			call(%f,%mini,%client);
		
		%mini.resetCapturePoints();
	}
	else
	{
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onMinigameUpdateModeSettings";
		if(isFunction(%f))
			call(%f,%mini,%client,%datastring);
	}
	
	if((%mini.changedHelpText || %changedMode) && %mini.tdmHelpShow)
	{
		%mini.changedHelpText = "";
		%mini.tdmLastHelpText = %mini.tdmHelpText;
		%client.lastTDMDataTime = ""; //reset so the help text is shown for the owner
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			servercmdmodehelp(%mini.member[%i]);
		}
	}
	
	if(!%reset || (%changedMode && !(%nostartmessage && %reset)))
		for(%i=0;%i<%mini.numMembers;%i++)
	if(%respawn[%mini.member[%i]])
		%mini.member[%i].instantRespawn();
}

function servercmdsetGameModeRule(%client,%i,%r)
{
	%client.modeRule[%i] = %r;
}

function servercmdsetGeneralRule(%client,%i,%r)
{
	%client.modeGeneralRule[%i] = %r;
}

function servercmdsetModeHelpText(%client,%text)
{
	if(!isObject(%client.minigame))
		return;
	if(%client.minigame.owner != %client)
		return;
	%text = getSubStr(%text,0,$Pref::Server::MaxChatLen);
	if(getLine(%client.minigame.tdmLastHelpText,0) !$= %text)
		%client.minigame.changedHelpText = 1;
	%client.minigame.tdmHelpText = %text;
	%client.minigame.tdmHelpTextLines = 0;
}

function servercmdaddModeHelpText(%client,%text)
{
	if(!isObject(%client.minigame))
		return;
	if(%client.minigame.owner != %client)
		return;
	%text = getSubStr(%text,0,$Pref::Server::MaxChatLen);
	if(getLine(%client.minigame.tdmLastHelpText,%client.minigame.tdmHelpTextLines++) !$= %text)
		%client.minigame.changedHelpText = 1;
	%client.minigame.tdmHelpText = %client.minigame.tdmHelpText NL %text;
	if(getLineCount(%client.minigame.tdmHelpText) > 5)
		%client.minigame.tdmHelpText = getRecords(%client.minigame.tdmHelpText,0,4);
}

function servercmdjointeam(%client,%t1,%t2,%t3,%t4,%t5)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	%name = trim(getSubStr(%t1 SPC %t2 SPC %t3 SPC %t4 SPC %t5,0,19));
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	%mini = %client.minigame;
	if(%mini.gameTeamsLock == 1 && %client.tdmTeam != -1)
	{
		if(%mini.gameAutoSort == 2)
		{
			messageclient(%client,'',"\c5You cannot swap teams while \c3Auto Sort\c5 is in \c3Fix\c5 mode.");
			return;
		}
		else if(%name $= "")
		{
			messageclient(%client,'',"\c5You cannot join or leave teams while teams are locked.");
			return;
		}
		%client.lastTDMDataTime = 0;
		servercmdswapteam(%client,%t1,%t2,%t3,%t4,%t5);
		return;
	}
	if(%name $= "")
	{
		if(%client.tdmteam == -1)
		{
			messageclient(%client,'',"\c5You aren't in a team.");
			return;
		}
		%mini.messageAll('',"\c3" @ %client.getPlayerName() @ "\c5 left " @ teamName(%mini,%client.tdmteam) @ "\c5.");
		if(%mini.teamLeader[%client.tdmTeam] == %client)
			%mini.teamLeader[%client.tdmTeam] = "";
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
		if(isFunction(%f))
			call(%f,%mini,%client,%client.tdmTeam,-1);
		
		if(%mini.swapTeam[%client.tdmTeam] == %client)
		{
			cancel(%mini.swapSched[%client.tdmTeam]);
			%mini.swapTeam[%client.tdmTeam] = "";
			%mini.swapSched[%client.tdmTeam] = "";
		}
		
		%client.tdmteam = -1;
		%client.instantRespawn();
		servercmdrequestTDMPlayerList(%mini.owner);
		return;
	}
	%found = -1;
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i] && %mini.teamName[%i] $= %name)
		{
			%found = %i;
		}
	}
	if(%found == -1)
	{
		if(!%mini.teamExists[0])
		{
			%mini.messageAll('',"\c5No teams exist.");
			return;
		}
		messageclient(%client,'',"\c5No team with that name exists. Available teams:");
		for(%i=0;%i<6;%i++)
		{
			if(%mini.teamExists[%i])
			{
				messageclient(%client,'',teamName(%mini,%i));
			}
		}
		return;
	}
	if(%client.tdmteam == %found)
	{
		messageclient(%client,'',"\c5You are already in that team.");
		return;
	}
	%mini.messageAll("tdmMessage","\c3" @ %client.getPlayerName() @ "\c5 has joined " @ teamName(%mini,%found) @ "\c5.");
	if(%mini.teamLeader[%client.tdmTeam] == %client)
		%mini.teamLeader[%client.tdmTeam] = "";
	
	%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
	if(isFunction(%f))
		call(%f,%mini,%client,%client.tdmTeam,%found);
	
	if(%mini.swapTeam[%client.tdmTeam] == %client)
	{
		cancel(%mini.swapSched[%client.tdmTeam]);
		%mini.swapTeam[%client.tdmTeam] = "";
		%mini.swapSched[%client.tdmTeam] = "";
	}
	%client.tdmteam = %found;
	%client.instantRespawn();
	servercmdrequestTDMPlayerList(%mini.owner);
}

function servercmdteamcount(%client)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	%mini = %client.minigame;
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		%count[%cl.tdmTeam]++;
	}
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
		{
			if(%count[%i] $= ""){%count[%i] = 0;}
				messageClient(%client,'',teamName(%mini,%i) @ "\c5: " @ %count[%i]);
		}
	}
	if(%count[-1] $= ""){%count[-1] = 0;}
		messageClient(%client,'',"\c3Players in no team\c5: " @ %count[-1]);
}

function servercmdteamlist(%client)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	%mini = %client.minigame;
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
			messageClient(%client,'',teamName(%mini,%i));
	}
}

function servercmdmodehelp(%client)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	
	if(!isObject(%client.minigame))
	{
		messageclient(%client,'',"\c5You are not in a mini-game.");
		return;
	}
	
	%mini = %client.minigame;
	%text = %mini.tdmHelpText;
	
	messageClient(%client,'',"\c3" @ gameModeIDToTitle(%mini.gamemode));
	
	if(trim(%text) !$= "")
	{
		for(%i=0;%i<getLineCount(%text);%i++)
		{
			%line = getLine(%text,%i);
			while(strPos(%line,"<team:") >= 0)
			{
				%pos = strPos(%line,"<team:")+6;
				%tag = getSubStr(%line,%pos,strLen(%line));
				%pos2 = strPos(%tag,">");
				if(%pos2 == -1)
				{
					%line = "<color:FF0000>ERROR: Invalid <team> ML tag";
					break;
				}
				%tag = getSubStr(%tag,0,%pos2);
				%line = strReplace(%line,"<team:"@%tag@">","<spush>" @ (%mini.teamExists[%tag] ? teamName(%mini,%tag) : ("\c3Team " @ %tag+1)) @ "<spop>");
				%k++;
				if(%k > 10)
				{
					%line = "<color:FF0000>ERROR: Invalid <team> ML tag";
					break;
				}
			}
			%k = 0;
			while(strPos(%line,"<rule:") >= 0)
			{
				%pos = strPos(%line,"<rule:")+6;
				%tag = getSubStr(%line,%pos,strLen(%line));
				%pos2 = strPos(%tag,">");
				if(%pos2 == -1)
				{
					%line = "<color:FF0000>ERROR: Invalid <rule> ML tag";
					break;
				}
				%tag = getSubStr(%tag,0,%pos2);
				%line = strReplace(%line,"<rule:"@%tag@">","<spush><color:FFFF00>" @ getRuleReadableValue(%mini,%tag) @ "<spop>");
				%k++;
				if(%k > 10)
				{
					%line = "<color:FF0000>ERROR: Invalid <rule> ML tag";
					break;
				}
			}
			messageClient(%client,'',"<color:FF00FF>" @ %line);
		}
	}
	else
	{
		messageClient(%client,'',"<color:FF00FF>No help text has been set for this minigame.");
	}
}

function servercmdswapteam(%client,%t1,%t2,%t3,%t4,%t5)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	
	%name = trim(getSubStr(%t1 SPC %t2 SPC %t3 SPC %t4 SPC %t5,0,19));
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	%mini = %client.minigame;
	if(%mini.gameTeamsLock == 0)
	{
		servercmdjointeam(%client,%t1,%t2,%t3,%t4,%t5);
		return;
	}
	if(%mini.gameAutoSort == 2)
	{
		messageclient(%client,'',"\c5You cannot swap teams while \c3Auto Sort\c5 is in \c3Fix\c5 mode.");
		return;
	}
	
	if(%name $= "")
	{
		if(!%mini.teamExists[0])
		{
			%mini.messageAll('',"\c5No teams exist.");
			return;
		}
		messageclient(%client,'',"\c5Pick a team to join.");
		for(%i=0;%i<6;%i++)
		{
			if(%mini.teamExists[%i])
			{
				messageclient(%client,'',teamName(%mini,%i));
			}
		}
		return;
	}
	
	%found = -1;
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i] && %mini.teamName[%i] $= %name)
		{
			%found = %i;
		}
	}
	if(%found == -1)
	{
		if(!%mini.teamExists[0])
		{
			%mini.messageAll('',"\c5No teams exist.");
			return;
		}
		messageclient(%client,'',"\c5No team with that name exists. Available teams:");
		for(%i=0;%i<6;%i++)
		{
			if(%mini.teamExists[%i])
			{
				messageclient(%client,'',teamName(%mini,%i));
			}
		}
		return;
	}
	
	if(%client.tdmteam == %found)
	{
		messageclient(%client,'',"\c5You are already in that team.");
		return;
	}
	
	if(isObject(%mini.swapTeam[%found]))
	{
		if(%client == %mini.swapTeam[%found])
			%pl = "\c5The poll is still going, please wait until it is done.";
		else
			%pl = clientTeamName(%mini.swapTeam[%found]) SPC "\c5is already trying to swap to that team. Please wait until they are done.";
		messageClient(%client,'',%pl);
		return;
	}
	
	//If you're trying to swap into the same team while someone is trying to move into yours, swap those two
	if(isObject(%mini.swapTeam[%client.tdmTeam]) && %mini.swapTeam[%client.tdmTeam].tdmTeam == %found)
	{
		servercmdAcceptSwap(%client);
		return;
	}
	
	if(%client.lastTDMSwapTime !$= "" && ($Sim::Time - %client.lastTDMSwapTime) < 60)
	{
		messageClient(%client,'','\c5You can only attempt to swap teams once a minute. Time remaining: \c3%1\c5 seconds.',60 - mCeil($Sim::Time - %client.lastTDMSwapTime));
		return;
	}
	%client.lastTDMSwapTime = $Sim::Time;
	
	%msg = clientTeamName(%client) SPC "\c5wants to swap teams with someone in " @ teamName(%mini,%found) @ "\c5. Type \c3/acceptswap\c5 within ten seconds to accept.";
	for(%i=0;%i<%client.minigame.numMembers;%i++)
	{
		%cl = %client.minigame.member[%i];
		if(%cl.tdmTeam == %found)
		{
			messageClient(%cl,'',%msg);
			%ok = 1;
		}
	}
	if(!%ok)
	{
		messageClient(%client,'',"\c5There is nobody on that team to swap with.");
		return;
	}
	
	messageClient(%client,'',"\c5A request has been sent out to the members of " @ teamName(%mini,%found) @ ".");
	%mini.swapTeam[%found] = %client;
	%mini.swapSched[%found] = %mini.schedule(10000,resetSwapTeam,%found);
}

function servercmdacceptswap(%client)
{
	//no need for command spam check, you can only initiate swaps every second
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	%mini = %client.minigame;
	if(%mini.gameTeamsLock == 0)
	{
		messageclient(%client,'',"\c5Teams are not locked, use \c3/jointeam\c5 to change teams.");
		return;
	}
	
	if(%client.tdmTeam == -1)
	{
		messageclient(%client,'',"\c5You aren't in a team.");
		return;
	}
	
	if(!isObject(%mini.swapTeam[%client.tdmTeam]))
	{
		messageclient(%client,'',"\c5Nobody is currently trying to swap into your team.");
		return;
	}
	%swapcl = %mini.swapTeam[%client.tdmTeam];
	%team = %swapcl.tdmTeam;
	
	%mini.messageAll('',clientTeamName(%client) @ "\c5 was moved to " @ teamName(%mini,%team) @ "\c5. (\c3Swap Teams\c5)");
	%mini.messageAll('',clientTeamName(%swapcl) @ "\c5 was moved to " @ teamName(%mini,%client.tdmTeam) @ "\c5. (\c3Swap Teams\c5)");
	
	cancel(%mini.swapSched[%client.tdmTeam]);
	%mini.swapSched[%client.tdmTeam] = "";
	%mini.swapTeam[%client.tdmTeam] = "";
	
	if(%mini.teamLeader[%client.tdmTeam] == %client)
		%mini.teamLeader[%client.tdmTeam] = "";
	if(%mini.teamLeader[%swapcl.tdmTeam] == %swapcl)
		%mini.teamLeader[%swapcl.tdmTeam] = "";
	
	%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
	if(isFunction(%f))
	{
		call(%f,%mini,%client,%client.tdmTeam,%team);
		call(%f,%mini,%swapcl,%team,%client.tdmTeam);
	}
	
	%swapcl.tdmteam = %client.tdmTeam;
	%client.tdmteam = %team;
	
	%client.instantRespawn();
	%swapcl.instantRespawn();
	
	servercmdrequestTDMPlayerList(%mini.owner);
}

function MinigameSO::resetSwapTeam(%mini,%team)
{
	if(isObject(%mini.swapTeam[%team]))
		messageClient(%mini.swapTeam[%team],'',"\c5No member of " @ teamName(%mini,%team) @ "\c5 accepted your \c3Swap Teams\c5 offer.");
	
	%mini.swapTeam[%team] = "";
	%mini.swapSched[%team] = "";
	
	%msg = "\c5Nobody accepted the team swap.";
	for(%i=0;%i<%client.minigame.numMembers;%i++)
	{
		%cl = %client.minigame.member[%i];
		if(%cl.tdmTeam == %team)
		{
			messageClient(%cl,'',%msg);
		}
	}
}

function MinigameSO::resetCapturePoints(%this)
{
	%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_resetCapturePoints";
	if(isFunction(%f))
	{
		call(%f,%this);
		return;
	}
	
	if(!gameModeAttribute(%this.gamemode,"UsesTeams"))
		return;
	
	if(%this.useAllPlayersBricks)
	{
		for(%i=0;%i<%this.numMembers;%i++)
		{
			%group = %this.member[%i].brickGroup;
			if(!isObject(%group))
				continue;
			for(%j=0;%j<%group.tdmBrickCount;%j++)
			{
				%o = %group.tdmBrick[%j];
				if(%o.dataBlock.isTDMCapturePoint)
				{
					%o.setTeamCapturable(-1,1);
					%o.setTeamAllied(%o.dataBlock.tdmSetAllied,%this.owner);
				}
			}
		}
	}
	else
	{
		%group = %this.owner.brickGroup;
		for(%j=0;%j<%group.tdmBrickCount;%j++)
		{
			%o = %group.tdmBrick[%j];
			if(%o.dataBlock.isTDMCapturePoint)
			{
				%o.setTeamCapturable(-1,1);
				%o.setTeamAllied(%o.dataBlock.tdmSetAllied,%this.owner);
			}
		}
	}
}

function servercmdsetteam(%client,%vicname,%t1,%t2,%t3,%t4,%t5)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	%name = trim(getSubStr(%t1 SPC %t2 SPC %t3 SPC %t4 SPC %t5,0,19));
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	if(%client.minigame.owner != %client)
	{
		messageclient(%client,'',"\c5You are not the owner of this mini-game.");
		return;
	}
	%mini = %client.minigame;
	if(%mini.gameAutoSort == 2)
	{
		messageclient(%client,'',"\c5You cannot move players between teams while \c3Auto Sort\c5 is in \c3Fix\c5 mode.");
		return;
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		if(strStr(strLwr(%mini.member[%i].getPlayerName()),strLwr(%vicname)) != -1)
		{
			%victim = %mini.member[%i];
			break;
		}
	}
	
	if(!isObject(%victim))
	{
		messageclient(%client,'',"\c5Nobody with that name is in your minigame.");
		return;
	}
	
	if(%name $= "")
	{
		if(%victim.tdmteam == -1)
		{
			messageclient(%client,'',"\c3" @ %victim.getPlayerName() @ "\c5 isn't in a team.");
			return;
		}
		%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was removed from " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
		if(%mini.teamLeader[%victim.tdmTeam] == %victim)
			%mini.teamLeader[%victim.tdmTeam] = "";
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
		if(isFunction(%f))
			call(%f,%mini,%victim,%victim.tdmTeam,-1);
		
		if(%mini.swapTeam[%victim.tdmTeam] == %victim)
		{
			cancel(%mini.swapSched[%victim.tdmTeam]);
			%mini.swapTeam[%victim.tdmTeam] = "";
			%mini.swapSched[%victim.tdmTeam] = "";
		}
		
		%victim.tdmteam = -1;
		%victim.instantRespawn();
		servercmdrequestTDMPlayerList(%mini.owner);
		return;
	}
	%found = -1;
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i] && %mini.teamName[%i] $= %name)
		{
			%found = %i;
		}
	}
	if(%found == -1)
	{
		if(!%mini.teamExists[0])
		{
			messageClient(%client,'',"\c5No teams exist.");
			return;
		}
		messageclient(%client,'',"\c5No team with that name exists. Available teams:");
		for(%i=0;%i<6;%i++)
		{
			if(%mini.teamExists[%i])
			{
				messageclient(%client,'',teamName(%mini,%i));
			}
		}
		return;
	}
	if(%victim.tdmteam == %found)
	{
		messageclient(%client,'',"\c3" @ %victim.getPlayerName() @ "\c5 is already in that team.");
		return;
	}
	%mini.messageAll("tdmMessage","\c3" @ %victim.getPlayerName() @ "\c5 was put into " @ teamName(%mini,%found) @ "\c5.");
	if(%mini.teamLeader[%victim.tdmTeam] == %victim)
		%mini.teamLeader[%victim.tdmTeam] = "";
	
	%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
	if(isFunction(%f))
		call(%f,%mini,%victim,%victim.tdmTeam,%found);
	
	if(%mini.swapTeam[%victim.tdmTeam] == %victim)
	{
		cancel(%mini.swapSched[%victim.tdmTeam]);
		%mini.swapTeam[%victim.tdmTeam] = "";
		%mini.swapSched[%victim.tdmTeam] = "";
	}
	%victim.tdmteam = %found;
	%victim.instantRespawn();
	servercmdrequestTDMPlayerList(%mini.owner);
}

function servercmdtdmguisetteam(%client,%player,%team)
{
	if((getSimTime() - %client.lastTDMDataTime) < 500)
		return;
	%client.lastTDMDataTime = getSimTime();
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
		return;
	
	if(%client.minigame.owner != %client)
		return;
	
	%mini = %client.minigame;
	if(%mini.gameAutoSort == 2)
	{
		commandtoclient(%client,'messageboxok',"Set Team","You cannot move players between teams while Auto Sort is in Fix mode.");
		return;
	}
	
	%victim = %mini.member[%player];
	
	if(!isObject(%victim))
	{
		commandtoclient(%client,'messageboxok',"Set Team","Select a player to move.");
		return;
	}
	
	if(%team == -1 || !%mini.teamExists[%team])
	{
		if(%victim.tdmteam == -1)
		{
			commandtoclient(%client,'messageboxok',"Set Team",%victim.getPlayerName() @ " isn't in a team.");
			return;
		}
		%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was removed from " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
		if(%mini.teamLeader[%victim.tdmTeam] == %victim)
			%mini.teamLeader[%victim.tdmTeam] = "";
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
		if(isFunction(%f))
			call(%f,%mini,%victim,%victim.tdmTeam,-1);
		
		if(%mini.swapTeam[%victim.tdmTeam] == %victim)
		{
			cancel(%mini.swapSched[%victim.tdmTeam]);
			%mini.swapTeam[%victim.tdmTeam] = "";
			%mini.swapSched[%victim.tdmTeam] = "";
		}
		%victim.tdmteam = -1;
		%victim.instantRespawn();
		servercmdrequestTDMPlayerList(%mini.owner);
		return;
	}
	
	%found = %team;
	
	if(%victim.tdmteam == %found)
	{
		commandtoclient(%client,'messageboxok',"Set Team",%victim.getPlayerName() @ " is already in that team.");
		return;
	}
	%mini.messageAll("tdmMessage","\c3" @ %victim.getPlayerName() @ "\c5 was put into " @ teamName(%mini,%found) @ "\c5.");
	if(%mini.teamLeader[%victim.tdmTeam] == %victim)
		%mini.teamLeader[%victim.tdmTeam] = "";
	
	%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
	if(isFunction(%f))
		call(%f,%mini,%victim,%victim.tdmTeam,%found);
	
	if(%mini.swapTeam[%victim.tdmTeam] == %victim)
	{
		cancel(%mini.swapSched[%victim.tdmTeam]);
		%mini.swapTeam[%victim.tdmTeam] = "";
		%mini.swapSched[%victim.tdmTeam] = "";
	}
	
	%victim.tdmteam = %found;
	%victim.instantRespawn();
	servercmdrequestTDMPlayerList(%mini.owner);
}

function servercmdsetlead(%client,%vicname,%t1,%t2,%t3,%t4,%t5)
{
	if((getSimTime() - %client.lastTDMDataTime) < 1000)
		return;
	%client.lastTDMDataTime = getSimTime();
	%name = trim(getSubStr(%t1 SPC %t2 SPC %t3 SPC %t4 SPC %t5,0,19));
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	if(%client.minigame.owner != %client)
	{
		messageclient(%client,'',"\c5You are not the owner of this mini-game.");
		return;
	}
	%mini = %client.minigame;
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		if(strStr(strLwr(%mini.member[%i].getPlayerName()),strLwr(%vicname)) != -1)
		{
			%victim = %mini.member[%i];
			break;
		}
	}
	
	if(!isObject(%victim))
	{
		messageclient(%client,'',"\c5Nobody with that name is in your minigame.");
	}
	
	if(%name $= "")
	{
		if(%victim.tdmteam == -1)
		{
			messageclient(%client,'',"\c3" @ %victim.getPlayerName() @ "\c5 isn't in a team.");
			return;
		}
		else
		{
			if(%mini.teamLeader[%victim.tdmTeam] == %victim)
			{
				%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
				%mini.teamLeader[%victim.tdmTeam] = "";
				%victim.instantRespawn();
				servercmdrequestTDMPlayerList(%mini.owner);
				return;
			}
			else
			{
				messageclient(%client,'',"\c3" @ %victim.getPlayerName() @ "\c5 isn't the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
				return;
			}
		}
	}
	
	%found = -1;
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i] && %mini.teamName[%i] $= %name)
		{
			%found = %i;
		}
	}
	
	if(%mini.gameAutoSort == 2)
	{
		if(%victim.tdmteam != %found)
		{
			messageclient(%client,'',"\c5You cannot move players between teams while \c3Auto Sort\c5 is in \c3Fix\c5 mode.");
			return;
		}
		if(%found == -1)
		{
			if(!%mini.teamExists[0])
			{
				messageclient(%client,'',"\c5No teams exist.");
				return;
			}
			messageclient(%client,'',"\c5No team with that name exists. Available teams:");
			for(%i=0;%i<6;%i++)
			{
				if(%mini.teamExists[%i])
				{
					messageclient(%client,'',teamName(%mini,%i));
				}
			}
			return;
		}
		if(%mini.teamLeader[%found] != %victim)
		{
			%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was set as the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			if(isObject(%mini.teamLeader[%found]))
			{
				%mini.messageAll('',"\c3" @ %mini.teamLeader[%found].getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
				if(isObject(%mini.teamLeader[%found].player))
					%mini.teamLeader[%found].schedule(10,instantRespawn);
			}
			%mini.teamLeader[%found] = %victim;
			%victim.instantRespawn();
			servercmdrequestTDMPlayerList(%mini.owner);
			return;
		}
		else
		{
			messageclient(%client,'',"\c3" @ %victim.getPlayerName() @ "\c5 is already the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			return;
		}
		return;
	}
	
	if(%found == -1)
	{
		if(!%mini.teamExists[0])
		{
			messageclient(%client,'',"\c5No teams exist.");
			return;
		}
		messageclient(%client,'',"\c5No team with that name exists. Available teams:");
		for(%i=0;%i<6;%i++)
		{
			if(%mini.teamExists[%i])
			{
				messageclient(%client,'',teamName(%mini,%i));
			}
		}
		return;
	}
	if(%victim.tdmteam == %found)
	{
		if(%mini.teamLeader[%found] != %victim)
		{
			%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was set as the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			if(isObject(%mini.teamLeader[%found]))
			{
				%mini.messageAll('',"\c3" @ %mini.teamLeader[%found].getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
				if(isObject(%mini.teamleader[%found].player))
					%mini.teamLeader[%found].schedule(10,instantRespawn);
			}
			%mini.teamLeader[%found] = %victim;
			%victim.instantRespawn();
			servercmdrequestTDMPlayerList(%mini.owner);
			return;
		}
		else
		{
			messageclient(%client,'',"\c3" @ %victim.getPlayerName() @ "\c5 is already the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			return;
		}
	}
	else
	{
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
		if(isFunction(%f))
			call(%f,%mini,%victim,%victim.tdmTeam,%found);
		if(%mini.swapTeam[%victim.tdmTeam] == %victim)
		{
			cancel(%mini.swapSched[%victim.tdmTeam]);
			%mini.swapTeam[%victim.tdmTeam] = "";
			%mini.swapSched[%victim.tdmTeam] = "";
		}
		%victim.tdmteam = %found;
		%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was put into and set as the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
		if(isObject(%mini.teamLeader[%found]))
		{
			%mini.messageAll('',"\c3" @ %mini.teamLeader[%found].getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			if(isObject(%mini.teamLeader[%found].player))
				%mini.teamLeader[%found].schedule(10,instantRespawn);
		}
		%mini.teamLeader[%found] = %victim;
		%victim.instantRespawn();
		servercmdrequestTDMPlayerList(%mini.owner);
		return;
	}
}

function servercmdtdmguisetlead(%client,%player,%team)
{
	if((getSimTime() - %client.lastTDMDataTime) < 500)
		return;
	%client.lastTDMDataTime = getSimTime();
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
		return;
	
	if(%client.minigame.owner != %client)
		return;
	
	%mini = %client.minigame;
	
	%victim = %mini.member[%player];
	
	if(!isObject(%victim))
	{
		commandtoclient(%client,'messageboxok',"Set Leader","Select a player to move.");
	}
	
	if(%team == -1 || !%mini.teamExists[%team])
	{
		if(%victim.tdmteam == -1)
		{
			commandtoclient(%client,'messageboxok',"Set Team",%victim.getPlayerName() @ " isn't in a team.");
			return;
		}
		else
		{
			if(%mini.teamLeader[%victim.tdmTeam] == %victim)
			{
				%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
				%mini.teamLeader[%victim.tdmTeam] = "";
				%victim.instantRespawn();
				servercmdrequestTDMPlayerList(%mini.owner);
				return;
			}
			else
			{
				commandtoclient(%client,'messageboxok',"Set Team",%victim.getPlayerName() @ " isn't the leader of " @ %mini.teamName[%victim.tdmTeam] @ ".");
				return;
			}
		}
	}
	
	%found = %team;
	
	if(%mini.gameAutoSort == 2)
	{
		if(%victim.tdmteam != %found)
		{
			commandtoclient(%client,'messageboxok',"Set Team","You cannot move players between teams while Auto Sort is in Fix mode.");
			return;
		}
		if(%mini.teamLeader[%found] != %victim)
		{
			%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was set as the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			if(isObject(%mini.teamLeader[%found]))
			{
				%mini.messageAll('',"\c3" @ %mini.teamLeader[%found].getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
				if(isObject(%mini.teamLeader[%found].player))
					%mini.teamLeader[%found].schedule(10,instantRespawn);
			}
			%mini.teamLeader[%found] = %victim;
			%victim.instantRespawn();
			servercmdrequestTDMPlayerList(%mini.owner);
			return;
		}
		else
		{
			commandtoclient(%client,'messageboxok',"Set Team",%victim.getPlayerName() @ " is already the leader of " @ %mini.teamName[%victim.tdmTeam] @ ".");
			return;
		}
		return;
	}
	
	if(%victim.tdmteam == %found)
	{
		if(%mini.teamLeader[%found] != %victim)
		{
			%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was set as the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			if(isObject(%mini.teamLeader[%found]))
			{
				%mini.messageAll('',"\c3" @ %mini.teamLeader[%found].getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
				if(isObject(%mini.teamLeader[%found].player))
					%mini.teamLeader[%found].schedule(10,instantRespawn);
			}
			%mini.teamLeader[%found] = %victim;
			%victim.instantRespawn();
			servercmdrequestTDMPlayerList(%mini.owner);
			return;
		}
		else
		{
			commandtoclient(%client,'messageboxok',"Set Team",%victim.getPlayerName() @ " is already the leader of " @ %mini.teamName[%victim.tdmTeam] @ ".");
			return;
		}
	}
	else
	{
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
		if(isFunction(%f))
			call(%f,%mini,%victim,%victim.tdmTeam,%found);
		if(%mini.swapTeam[%victim.tdmTeam] == %victim)
		{
			cancel(%mini.swapSched[%victim.tdmTeam]);
			%mini.swapTeam[%victim.tdmTeam] = "";
			%mini.swapSched[%victim.tdmTeam] = "";
		}
		%victim.tdmteam = %found;
		%mini.messageAll('',"\c3" @ %victim.getPlayerName() @ "\c5 was put into and set as the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
		if(isObject(%mini.teamLeader[%found]))
		{
			%mini.messageAll('',"\c3" @ %mini.teamLeader[%found].getPlayerName() @ "\c5 is no longer the leader of " @ teamName(%mini,%victim.tdmteam) @ "\c5.");
			if(isObject(%mini.teamLeader[%found].player))
				%mini.teamLeader[%found].schedule(10,instantRespawn);
		}
		%mini.teamLeader[%found] = %victim;
		%victim.instantRespawn();
		servercmdrequestTDMPlayerList(%mini.owner);
		return;
	}
}

function servercmdleaveteam(%client)
{
	servercmdjointeam(%client,"");
}

function servercmdsortplayers(%client)
{
	if((getSimTime() - %client.lastTDMDataTime) < 2000)
		return;
	%client.lastTDMDataTime = getSimTime();
	if(!isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
	{
		messageclient(%client,'',"\c5You are not in a Team Deathmatch mini-game.");
		return;
	}
	if(%client.minigame.owner != %client)
	{
		messageclient(%client,'',"\c5You are not the owner of this mini-game.");
		return;
	}
	%mini = %client.minigame;
	
	%mini.sortMemberOffset = (%mini.sortMemberOffset + 1) % 100000;
	%mini.sortMemberTeams("(Sort Teams)");
}

function servercmdtdmstoreuniform(%client,%team,%ind,%data)
{
	if(!isInt(%team) || %team < 0 || %team > 5)
		return;
	if(!isInt(%ind) || %ind < 0 || %ind > 3)
		return;
	
	%client.tdmStoreUniform_part[%team,%ind] = %data;
	
	if(%ind == 2)
	{
		%client.tdmStoreUniform[%team] = trim(%client.tdmStoreUniform_part[%team,0] TAB
		%client.tdmStoreUniform_part[%team,1] TAB
		%client.tdmStoreUniform_part[%team,2]);
	}
}

function servercmdtdmstoreluniform(%client,%team,%ind,%data)
{
	if(!isInt(%team) || %team < 0 || %team > 5)
		return;
	if(!isInt(%ind) || %ind < 0 || %ind > 3)
		return;
	
	%client.tdmStoreLUniform_part[%team,%ind] = %data;
	
	%client.tdmStoreLUniform[%team] = trim(%client.tdmStoreLUniform_part[%team,0] TAB
	%client.tdmStoreLUniform_part[%team,1] TAB
	%client.tdmStoreLUniform_part[%team,2]);
}

//Support Functions
function RGBToHEX(%col) //In the form of R G B 0-1
{
	%red = (getWord(%col,0)*255);
	%r = getSubStr("0123456789ABCDEF",(%red - (%red % 16))/16,1) @ getSubStr("0123456789ABCDEF",(%red % 16),1);
	
	%green = (getWord(%col,1)*255);
	%g = getSubStr("0123456789ABCDEF",(%green - (%green % 16))/16,1) @ getSubStr("0123456789ABCDEF",(%green % 16),1);
	
	%blue = (getWord(%col,2)*255);
	%b = getSubStr("0123456789ABCDEF",(%blue - (%blue % 16))/16,1) @ getSubStr("0123456789ABCDEF",(%blue % 16),1);
	
	return %r @ %g @ %b;
}

function getRuleReadableValue(%mini,%rule)
{
	%r = %mini.tdmModeRule[%rule];
	%str = GameModeStorerSO.modeRuleStr[%mini.gamemode,%rule];
	switch$(firstWord(%str))
	{
		case "bool":
			if(%r)
				return 1;
			else
				return 0;
			
		case "list":
			%ok=0;
			if(strPos(%str,"\t") == -1)
			{
				for(%j=2;%j<getWordCount(%str);%j+=2)
				{
					if(%r $= getWord(%str,%j))
					{
						return getWord(%str,%j-1);
					}
				}
			}
			else
			{
				for(%j=2;%j<getFieldCount(%str);%j+=2)
				{
					if(%r $= getField(%str,%j))
					{
						return getField(%str,%j-1);
					}
				}
			}
			return "";
			
		case "dataBlock":
			if(isObject(%r))
				if(getWord(%str,1) $= "Sound")
				return fileName(%r.fileName);
			else  
				return %r.uiName;
			else
				return "NONE";
			
		case "int":
			return %r;
			
		case "string":
			return %r;
	}
}

function teamName(%mini,%team)
{
	return "<color:" @ RGBToHEX(getColorIDTable(%mini.teamCol[%team])) @ ">" @ %mini.teamName[%team];
}

function clientTeamName(%client,%teamName)
{
	if(!isObject(%client))
		return "";
	
	if(%client.isSpaceBotAI)
		%name = %client.getBotName();
	else
		%name = %client.getPlayerName();
	
	if(!isObject(%client.minigame) || %client.tdmTeam == -1 || !%client.minigame.teamExists[%client.tdmTeam])
	{
		return "<color:FFFF00>" @ %name;
	}
	else if(%teamName)
	{
		return teamName(%client.minigame,%client.tdmTeam);
	}
	else
	{
		return "<color:" @ RGBToHEX(getColorIDTable(%client.minigame.teamCol[%client.tdmTeam])) @ ">" @ %name;
	}
}

function MinigameSO::setTimeLimit(%mini,%t)
{
	cancel(%mini.tdmTimeSched);
	
	if(%t <= 0)
	{
		%mini.tdmTimeLimit = "";
		return;
	}
	
	%mini.tdmTimeLimit = %t;
	%mini.tdmTimeSched = %mini.schedule(60000,timeLimitClock);
}

function MinigameSO::addTimeLimit(%mini,%t)
{
	cancel(%mini.tdmTimeSched);
	%mini.tdmTimeSched = "";
	
	%mini.tdmTimeLimit = %mini.tdmTimeLimit + %t;
	
	if(%t <= 0)
	{
		%mini.tdmTimeSched = "";
		%mini.tdmTimeLimit = "";
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onTimeLimit";
		if(isFunction(%f))
			call(%f,%mini);
		
		return;
	}
	
	%mini.tdmTimeSched = %mini.schedule(60000,timeLimitClock);
}

function MinigameSO::timeLimitClock(%mini)
{
	%mini.tdmTimeLimit--;
	if(%mini.tdmTimeLimit == 5)
	{
		%mini.messageAll('',"\c5Five minutes remaining.");
	}
	else if(%mini.tdmTimeLimit == 2)
	{
		%mini.messageAll('',"\c5Two minutes remaining!");
	}
	else if(%mini.tdmTimeLimit == 1)
	{
		%mini.messageAll('',"\c5One minute remaining!");
	}
	else if(%mini.tdmTimeLimit == 0)
	{
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onTimeLimit";
		if(isFunction(%f))
			call(%f,%mini);
		
		%mini.tdmTimeSched = "";
		return;
	}
	%mini.tdmTimeSched = %mini.schedule(60000,timeLimitClock);
}

function MinigameSO::getTimeLimit(%mini)
{
	return %mini.tdmTimeLimit;
}

function MinigameSO::setLivesLimit(%mini,%t)
{
	%oldLimit = %mini.tdmLivesLimit;
	if(%t <= 0)
	{
		%mini.tdmLivesLimit = "";
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%c = %mini.member[%i];
			cancel(%c.tdmCameraSched);
			%c.tdmLives = "";
			if(!isObject(%c.player))
				%c.instantRespawn();
			%c.bottomPrint("",0.01);
		}
	}
	else
	{
		%mini.tdmLivesLimit = %t;
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%c = %mini.member[%i];
			cancel(%c.tdmCameraSched);
			%l = %c.tdmLives;
			%c.tdmLives = %t;
			if(%l == 0 && %oldLimit !$= "")
			{
				if(!isObject(%c.player))
					%c.instantRespawn();
				%c.bottomPrint("",0.01);
			}
		}
	}
}

function MinigameSO::getLivesLimit(%mini)
{
	return %mini.tdmLivesLimit;
}

function MinigameSO::setPointsLimit(%mini,%t)
{
	if(%t <= 0)
	{
		%mini.tdmPointsLimit = "";
		return;
	}
	%mini.tdmPointsLimit = %t;
	%mini.checkPointsLimit();
}

function MinigameSO::getPointsLimit(%mini)
{
	return %mini.tdmPointsLimit;
}

function MinigameSO::checkPointsLimit(%mini)
{
	//This will also account for changing the points limit in the middle of a minigame, although that doesn't happen normally
	//In Deathmatch/Team Deathmatch mode, it resets the minigame and scores when you change this rule
	
	//don't do the limits if you're resetting the minigame - setScore(0) causes teams to win!
	if(%mini.tdmResetCheck)
		return;
	
	if(%mini.roundWon)
		return;
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];      
		if(%cl.score $= "")
			%cl.score = 0;
		if(%mini.teamExists[%cl.tdmTeam] && %cl.tdmTeam != -1)
		{
			%score[%cl.tdmTeam] += %mini.member[%i].score;
		}
		else if(%cl.score > %highestScore)
		{
			%highestScore = %cl.score;
		}
	}
	
	for(%i=0;%i<6;%i++)
	{
		if(%score[%i] $= "")
			%score[%i] = 0;
		if(%mini.teamExists[%i] && %score[%i] > %highestScore)
		{
			%highestScore = %score[%i];
		}
	}
	
	if(%highestScore < %mini.tdmPointsLimit)
		return;
	
	%winCount = -1;
	
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
		{
			if(%score[%i] == %highestScore)
			{
				%wins[%winCount++] = teamName(%mini,%i);
			}
		}
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(%cl.tdmTeam == -1)
		{
			if(%cl.score == %highestScore)
			{
				%wins[%winCount++] = "\c3" @ %cl.getPlayerName();
				if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
					%cl.player.emote(winStarProjectile,1);
				%cl.tdmRoundsWon++;
				%cl.play2d(rewardSound);
			}
		}
		else if(%score[%cl.tdmTeam] == %highestScore)
		{
			if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
				%cl.player.emote(winStarProjectile,1);
			%cl.tdmRoundsWon++;
			%cl.play2d(rewardSound);
		}
	}
	
	//%winCount cannot be zero as long as there is a player in the minigame
	//which there should be unless you're hacking it to bits for a dedicated
	//even so, the message won't actually be displayed to anyone if that's the case so it should be okay
	%msg = %wins[0];
	if(%winCount > 0)
	{
		for(%i=1;%i<%winCount;%i++)
		%msg = %msg @ "\c5, " @ %wins[%i];
		%msg = %msg @ "\c5 and " @ %wins[%winCount];
	}
	%msg = %msg @ "\c5 won this round with \c3" @ %highestScore @ "\c5 point" @ (%highestScore == 1 ? "" : "s") @ ". Resetting in five seconds...";
	%mini.messageAll('',%msg);
	
	%mini.roundWon = 1;
	%mini.roundSwapTeams = 0;
	%mini.schedule(5000,reset,%mini.owner);
}

function MinigameSO::getForceRespawn(%mini,%client)
{
	%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_getForceRespawn";
	if(isFunction(%f))
	{
		%val = call(%f,%mini,%client);
		if(%val !$= "")
			return %val;
	}
	
	return (%mini.tdmLivesLimit > 0 && %client.tdmLives > 0);
}

function MinigameSO::fixTeamOrder(%mini) //sorts the list of teams so there are no 'gaps'
{
	%lastEmpty = -1;
	for(%i=0;%i<6;%i++)
	{
		if(%lastEmpty == -1)
		{
			if(!%mini.teamExists[%i])
				%lastEmpty = %i;
		}
		else
		{
			if(%mini.teamExists[%i])
			{
				%mini.teamExists[%lastEmpty] = 1;
				%mini.teamName[%lastEmpty] = %mini.teamName[%i];
				%mini.teamCol[%lastEmpty] = %mini.teamCol[%i];
				%mini.teamUniform[%lastEmpty] = %mini.teamUniform[%i];
				%mini.leadUniform[%lastEmpty] = %mini.leadUniform[%i];
				%mini.teamPlayerData[%lastEmpty] = %mini.teamPlayerData[%i];
				%mini.teamLeaderData[%lastEmpty] = %mini.teamLeaderData[%i];
				
				%mini.teamExists[%i] = 0;
				%mini.teamName[%i] = "";
				%mini.teamCol[%i] = 0;
				%mini.teamUniform[%i] = "";
				%mini.leadUniform[%i] = "";
				%mini.teamPlayerData[%i] = "";
				%mini.teamLeaderData[%i] = "";
				
				for(%j=0;%j<5;%j++)
				{
					%mini.teamStartEquip[%lastEmpty,%j] = %mini.teamStartEquip[%i,%j];
					%mini.leadStartEquip[%lastEmpty,%j] = %mini.leadStartEquip[%i,%j];
					%mini.teamStartEquip[%i,%j] = "";
					%mini.leadStartEquip[%i,%j] = "";
				}
				
				for(%j=0;%j<%mini.numMembers;%j++)
				{
					%cl = %mini.member[%j];
					if(%cl.tdmTeam == %i)
					{
						%cl.tdmTeam = %lastEmpty;
						%cl.instantRespawn();
					}
				}
				
				%i = %lastEmpty;
				%lastEmpty = -1;
			}
		}
	}
}

function MinigameSO::displayModeScores(%mini)
{
	if(gameModeAttribute(%mini.gamemode,"UsesRounds"))
		%showRounds = 1;
	else
	{
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			if(%mini.member[%i].tdmRoundsWon > 0)
			{
				%showRounds = 1;
				break;
			}
		}
	}
	
	%highestScore = %mini.member0.score;
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(%cl.score $= "")
			%cl.score = 0;
		if(%mini.teamExists[%cl.tdmTeam] && %cl.tdmTeam != -1)
		{
			%score[%cl.tdmTeam] += %mini.member[%i].score;
		}
		else if(%cl.score > %highestScore)
		{
			%highestScore = %cl.score;
		}
	}
	for(%i=0;%i<6;%i++)
	{
		if(%score[%i] $= "")
			%score[%i] = 0;
		if(%mini.teamExists[%i] && %score[%i] > %highestScore)
		{
			%highestScore = %score[%i];
		}
	}
	
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
		{
			%string = ((%score[%i] == %highestScore) ? "<bitmap:base/client/ui/ci/trophy> " : "") @ teamName(%mini,%i) @ "\c5 has \c3" @ %score[%i] @ " \c5point" @ ((%score[%i] != 1 && %score[%i] != -1) ? "s" : "") @ ".";
			%mini.scoresList = (%mini.scoresList $= "" ? %string : %mini.scoresList TAB %string);
		}
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(%cl.tdmTeam == -1)
		{
			%string = ((%cl.score == %highestScore) ? "<bitmap:base/client/ui/ci/trophy> " : "") @ "\c3" @ %cl.getPlayerName() @ "\c5 has \c3" @ %cl.score @ " \c5point" @ ((%cl.score != 1 && %cl.score != -1) ? "s" : "") @ ".";
			%mini.scoresList = (%mini.scoresList $= "" ? %string : %mini.scoresList TAB %string);
		}
	}
	
	if(%showRounds)
	{
		%highestRounds = 0;
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%cl = %mini.member[%i];
			if(%cl.tdmRoundsWon $= "")
				%cl.tdmRoundsWon = 0;
			if(%cl.tdmRoundsWon > %highestRounds)
				%highestRounds = %cl.tdmRoundsWon;
		}
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%cl = %mini.member[%i];
			if(%cl.tdmRoundWon <= 0)
				continue;
			%string = ((%cl.tdmRoundsWon == %highestRounds) ? "<bitmap:base/client/ui/ci/trophy> " : "") @ clientTeamName(%cl,0) @ "\c5 has won in \c3" @ %cl.tdmRoundsWon @ " \c5round" @ (%cl.tdmRoundsWon != 1 ? "s" : "") @ ".";
			%mini.scoresList = (%mini.scoresList $= "" ? %string : %mini.scoresList TAB %string);
		}
	}
	
	if(%mini.scoresList !$= "")
		%mini.displayScoresList();
}

function MinigameSO::displayScoresList(%mini)
{
	%mini.bottomPrintAll(getField(%mini.scoresList,0),3);
	%mini.scoresList = getFields(%mini.scoresList,1);
	
	if(%mini.scoresList $= "")
		%mini.schedule(63000,displayModeScores);
	else
		%mini.schedule(2000,displayScoresList);
}

function MinigameSO::sortMemberTeams(%mini,%reason)
{
	%tcount = -1;
	if(%mini.numMembers <= 0)
		return;
	for(%i=0;%i<6;%i++)
	{
		%c = %mini.teamExists[%i];
		%mini.swapTeam[%i] = "";
		cancel(%mini.swapSched[%i]);
		%mini.swapSched[%i] = "";
		if(%c && %mini.teamAutoSortRatio[%i] > 0)
		{
			%team[%tcount++] = %i;
			%sortRatio = %sortRatio + %mini.teamAutoSortRatio[%i];
		}
	}
	if(%tcount == -1)
		return;
	if(%sortRatio == 0)
		return;
	%ratio = (%mini.numMembers + 1) / %sortRatio;
	for(%i=0;%i<%tcount+1;%i++)
	{
		%weight[%team[%i]] = %ratio * %mini.teamAutoSortRatio[%i];
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%num = (%i + %mini.sortMemberOffset) % (%mini.numMembers);
		%client = %mini.member[%num];
		%highestWeight = -1;
		for(%j=0;%j<%tcount+1;%j++)
		{
			%c = %team[%j];
			if(%weight[%c] > %highestweight)
			{
				%highestweight = %weight[%c];
				%lastteam = %c;
			}
		}
		
		if(%client.tdmteam != %lastteam)
		{
			if(%mini.teamLeader[%client.tdmTeam] == %client)
			{
				%mini.teamLeader[%client.tdmTeam] = "";
			}
			%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
			if(isFunction(%f))
				call(%f,%mini,%client,%client.tdmTeam,%lastteam);
			%client.tdmteam = %lastteam;
			%client.instantRespawn();
			%mini.messageAll("tdmMessage","\c3" @ %client.getPlayerName() @ "\c5 was put into " @ teamName(%mini,%lastteam) @ "\c5." SPC %reason);
		}
		%weight[%lastteam]--;
	}
	servercmdrequestTDMPlayerList(%mini.owner);
}

function MinigameSO::pickAutoSortTeam(%mini)
{
	%tcount = -1;
	if(%mini.numMembers <= 0)
		return -1;
	for(%i=0;%i<6;%i++)
	{
		%c = %mini.teamExists[%i];
		if(%c != 0 && %mini.teamAutoSortRatio[%i] > 0)
		{
			%team[%tcount++] = %i;
			%tfind[%i] = %tcount;
			%sortRatio = %sortRatio + %mini.teamAutoSortRatio[%i];
		}
	}
	if(%tcount == -1)
		return -1;
	if(%sortRatio == 0)
		return -1;
	%ratio = (%mini.numMembers + 1) / %sortRatio;
	for(%i=0;%i<%tcount+1;%i++)
	{
		%weight[%team[%i]] = %ratio * %mini.teamAutoSortRatio[%i];
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%c = %mini.member[%i];
		if(%c.tdmTeam != -1)
		{
			%weight[%tfind[%c.tdmTeam]]--;
		}
	}
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%client = %mini.member[%i];
		%highestWeight = -1;
		for(%j=0;%j<%tcount+1;%j++)
		{
			%c = %team[%j];
			if(%weight[%c] > %highestweight)
			{
				%highestweight = %weight[%c];
				%lastteam = %c;
			}
		}
		return %lastteam;
	}
}

function MinigameSO::dumpTeams(%mini)
{
	echo("Dump Teams: " @ %mini.title @ " (" @ %mini @ ")");
	%fix = 0;
	for(%i=0;%i<6;%i++)
	{
		if(%mini.teamExists[%i])
		{
			if(%fix == 1){%fix = 2;}
				echo(%i @ " - " @ %mini.teamName[%i]);
			echo("");
			echo("Team Color:");
			echo("ColorID: " @ %mini.teamCol[%i]);
			echo("RGB: " @ getColorIDTable(%mini.teamCol[%i]));
			echo("HEX: " @ rgbToHEX(getColorIDTable(%mini.teamCol[%i])));
			echo("Auto Sort Ratio: " @ %mini.teamAutoSortRatio[%i]);
			echo("");
			echo("Uniform Dump:");
			echo(%mini.teamUniform[%i]);
			echo(%mini.leadUniform[%i]);
			echo("");
			echo("Player Data: " @ %mini.teamPlayerData[%i] @ " - " @ %mini.teamPlayerData[%i].uiName);
			echo("");
			echo("Team Weapons:");
			for(%j=0;%j<5;%j++)
			{
				if(isObject(%mini.teamStartEquip[%i,%j]))
					echo(%j @ " - " @ %mini.teamStartEquip[%i,%j].getID() @ " - " @ %mini.teamStartEquip[%i,%j].uiName);
				else
					echo(%j @ " - NONE");
			}
			echo("");
			echo("Leader Data: " @ %mini.leadPlayerData[%i] @ " - " @ %mini.leadPlayerData[%i].uiName);
			echo("");
			echo("Leader Weapons:");
			for(%j=0;%j<5;%j++)
			{
				if(isObject(%mini.leadStartEquip[%i,%j]))
					echo(%j @ " - " @ %mini.leadStartEquip[%i,%j].getID() @ " - " @ %mini.leadStartEquip[%i,%j].uiName);
				else
					echo(%j @ " - NONE");
			}
			echo("Members:");
			%ok = 0;
			for(%j=0;%j<%mini.numMembers;%j++)
			{
				if(%mini.member[%j].tdmTeam == %i)
				{
					%ok = 1;
					echo(%mini.member[%j] @ " - " @ %mini.member[%j].getPlayerName());
				}
			}
			if(!%ok){echo("Nobody (team is empty)");}
				echo("--------");
		}
		else
		{
			if(%fix == 0){%fix = 1;}
				echo(%i @ " - Empty");
			echo("--------");
		}
	}
	echo("Players in no team:");
	%ok = 0;
	for(%j=0;%j<%mini.numMembers;%j++)
	{
		if(%mini.member[%j].tdmTeam == -1)
		{
			%ok = 1;
			echo(%mini.member[%j] @ " - " @ %mini.member[%j].getPlayerName());
		}
	}
	if(!%ok){echo("Nobody (everyone is in a team)");}
		if(%fix == 2)
	{
		echo("");
		echo("There is a gap in the team order.");
	}
}

//Datablocks
function defineTDMBrickDatablocks()
{
	if(isObject("brickTDMTeam1SpawnPointData"))
		return;
	//The loops are separate to make them appear in the brick menu in the correct order
	for(%i=0;%i<6;%i++)
	{
		datablock fxDTSBrickData(brick : brickSpawnPointData)
		{
			category = "SpaceMods";
			subCategory = "Team Deathmatch";
			uiName = "Team " @ %i+1 @ " Spawn Point";
			
			
			tdmSetAllied = %i+1;
			isTDMBrick = 1; //Team DM bricks are stored in the brick group to reduce searching
		};brick.setName("brickTDMTeam" @ %i+1 @ "SpawnPointData");
	}
	for(%i=0;%i<6;%i++)
	{
		datablock fxDTSBrickData(brick : brickVehicleSpawnData)
		{
			category = "SpaceMods";
			subCategory = "Team Deathmatch";
			uiName = "Team " @ %i+1 @ " Vehicle Spawn";
			
			
			tdmSetAllied = %i+1;
			isTDMBrick = 1;
		};brick.setName("brickTDMTeam" @ %i+1 @ "VehicleSpawnData");
	}
	datablock fxDTSBrickData(brick : brick6x6fdata)
	{
		uiName = "Team 1 Capture Point";
		category = "SpaceMods";
		subCategory = "Team Deathmatch";
		indestructable = 1;
		
		tdmSetAllied = 1;
		tdmCaptureHealth = 100;
		isTDMBrick = 1;
		isTDMCapturePoint = 1;
	};brick.setName("brickTDMTeam1CapPointData");
	datablock fxDTSBrickData(brick : brick6x6fdata)
	{
		uiName = "Team 2 Capture Point";
		category = "SpaceMods";
		subCategory = "Team Deathmatch";
		indestructable = 1;
		
		tdmSetAllied = 2;
		tdmCaptureHealth = 100;
		isTDMBrick = 1;
		isTDMCapturePoint = 1;
	};brick.setName("brickTDMTeam2CapPointData");
	datablock fxDTSBrickData(brick : brick6x6fdata)
	{
		uiName = "Team 3 Capture Point";
		category = "SpaceMods";
		subCategory = "Team Deathmatch";
		indestructable = 1;
		
		tdmSetAllied = 3;
		tdmCaptureHealth = 100;
		isTDMBrick = 1;
		isTDMCapturePoint = 1;
	};brick.setName("brickTDMTeam3CapPointData");
	datablock fxDTSBrickData(brick : brick6x6fdata)
	{
		uiName = "Neutral Capture Point";
		category = "SpaceMods";
		subCategory = "Team Deathmatch";
		indestructable = 1;
		
		tdmSetAllied = 0; //so it sets to Neutral instead of skipping
		tdmCaptureHealth = 100;
		isTDMBrick = 1;
		isTDMCapturePoint = 1;
	};brick.setName("brickTDMTeamNeutCapPointData");
	datablock fxDTSBrickData(brick : brick16x16fdata)
	{
		uiName = "Large Neutral Capture Point";
		category = "SpaceMods";
		subCategory = "Team Deathmatch";
		indestructable = 1;
		
		tdmSetAllied = 0; //so it sets to Neutral instead of skipping
		tdmCaptureHealth = 500;
		isTDMBrick = 1;
		isTDMCapturePoint = 1;
	};brick.setName("brickTDMTeamNeutBigCapPointData");
	datablock fxDTSBrickData(brick : brick16x16fdata)
	{
		uiName = "Large Team 1 Capture Point";
		category = "SpaceMods";
		subCategory = "Team Deathmatch";
		indestructable = 1;
		
		tdmSetAllied = 1;
		tdmCaptureHealth = 500;
		isTDMBrick = 1;
		isTDMCapturePoint = 1;
	};brick.setName("brickTDMTeam1BigCapPointData");
}
defineTDMBrickDatablocks();

//onPlayerTouch only works for one player object at a time. Using a trigger is better in this case.
datablock TriggerData(TDMPointTriggerData)
{
	tickPeriodMS = 100;
};

function TDMPointTriggerData::onEnterTrigger(%this,%trigger,%user)
{
	if(!(%user.getType() & $TypeMasks::PlayerObjectType))
		return;
	
	if(!isObject(%user.client))
		return;
	
	%trigger.playerSet.add(%user);
	
	if(!isObject(%trigger.spawnBrick))
		return;
	
	%client = %trigger.spawnBrick.getGroup().client;
	%mini = %client.minigame; 
	
	if(!isObject(%mini) || !gameModeAttribute(%mini.gameMode,"UsesTeams") || (%client != %mini.owner && !%mini.useallplayersbricks))
		return;
	
	if(%user.minigame != %mini)
		return;
	
	if(%user.client.tdmTeam == -1 || %user.client.tdmTeam > 2)
		return;
	
	if(%brick.tdmCaptureNum[%user.client.tdmTeam] == %brick.dataBlock.tdmCaptureHealth)
		return;
	
	for(%i=0;%i<%mini.numMembers;%i++)
	{
		%cl = %mini.member[%i];
		if(%cl.tdmTeam == %brick.tdmAlliedTeam-1 && isObject(%cl.player) && %cl.player.getState() !$= "Dead")
			%cl.player.emote(alarmProjectile,1);
	}
}

function TDMPointTriggerData::onLeaveTrigger(%this,%trigger,%user)
{
	if(%trigger.playerSet.isMember(%user))
		%trigger.playerSet.remove(%user);
}

function TDMPointTriggerData::onTickTrigger(%this,%trigger)
{
	%brick = %trigger.spawnBrick;
	%defTeam = %brick.tdmAlliedTeam-1;
	
	if(!isObject(%brick))
		return;
	
	if(%brick.isDead() || %brick.isFakeDead() || !%brick.isColliding())
		return;
	
	%client = %brick.getGroup().client;
	%mini = %client.minigame;
	if(!isObject(%mini) || !gameModeAttribute(%mini.gameMode,"UsesTeams") || (%client != %mini.owner && !%mini.useallplayersbricks))
		return;
	
	for(%i=0;%i<%trigger.playerSet.getCount();%i++)
	{
		%obj = %trigger.playerSet.getObject(%i);
		%cl = %obj.client;
		if(%cl.minigame != %mini)
			continue;
		
		if(%cl.tdmTeam == -1 || %cl.tdmTeam > 2)
			continue;
		
		if(!%brick.tdmPointCapturable[%cl.tdmTeam])
		{
			%cl.centerPrint("\c5This point is \c3locked\c5. " @ teamName(%mini,%cl.tdmTeam) @ "\c5 cannot capture it yet.",2);
			continue;
		}
		
		if(%obj.isCloaked || %obj.isCloaking)
		{
			%cl.centerPrint("\c5You cannot \c3capture\c5 while \c3Cloaked\c5!",2);
			return;
		}
		
		%numPlayers[%cl.tdmTeam]++;
		
		if(%cl.tdmTeam != %defTeam)
			%atkClient = %cl;
		
		if(%cl.tdmTeam == %defTeam)
			%defClient = %cl;
	}
	
	if(%defTeam == -1)
	{
		//Determine the highest two team IDs
		if(%numPlayers[0] > %numPlayers[1])
		{
			%atkTeamA = 0;
			if(%numPlayers[1] > %numPlayers[2])
			{
				%atkTeamB = 1;
				%lastAtkTeam = 2;
			}
			else
			{
				%atkTeamB = 2;
				%lastAtkTeam = 1;
			}
		}
		else
		{
			%atkTeamA = 1;
			if(%numPlayers[0] > %numPlayers[2])
			{
				%atkTeamB = 0;
				%lastAtkTeam = 2;
			}
			else
			{
				%atkTeamB = 2;
				%lastAtkTeam = 0;
			}
		}
	}
	else
	{
		//Get the two team IDs that aren't defending
		switch(%defTeam)
		{
			case 0:
				%atkTeamA = 1;
				%atkTeamB = 2;
			case 1:
				%atkTeamA = 0;
				%atkTeamB = 2;
			case 2:
				%atkTeamA = 0;
				%atkTeamB = 1;
		}
	}
	
	//Convert to real numbers just in case
	%numPlayers[%atkTeamA] = %numPlayers[%atkTeamA] + 0;
	%numPlayers[%atkTeamB] = %numPlayers[%atkTeamB] + 0;
	
	//Which team has greatest number of attackers
	if(%numPlayers[%atkTeamA] > %numPlayers[%atkTeamB])
	{
		%atkNum = %numPlayers[%atkTeamA]-%numPlayers[%atkTeamB];
		%atkTeam = %atkTeamA;
		%brick.tdmLastCapturer = %atkTeam;
		%brick.tdmCaptureNum[%atkTeamB] = 0;
		
		//If it's neutral, then erase progress for the third (last) 'Attacking' team
		if(%defTeam == -1)
			%brick.tdmCaptureNum[%lastAtkTeam] = 0;
	}
	else if(%numPlayers[%atkTeamA] < %numPlayers[%atkTeamB])
	{
		%atkNum = %numPlayers[%atkTeamB]-%numPlayers[%atkTeamA];
		%atkTeam = %atkTeamB;
		%brick.tdmLastCapturer = %atkTeam;
		%brick.tdmCaptureNum[%atkTeamA] = 0;
		
		//If it's neutral, then erase progress for the third (last) 'Attacking' team
		if(%defTeam == -1)
			%brick.tdmCaptureNum[%lastAtkTeam] = 0;
	}
	else
	{
		%atkNum = %numPlayers[%atkTeamA];
		%atkTeam = %brick.tdmLastCapturer;
		
		if(%defTeam == -1)
			%atkNum = 0;
	}
	
	if(%defTeam == -1)
	{
		%defNum = 0;
		%defCol = getColorIDTable(getClosestPaintColor("0.5 0.5 0.5 1"));
	}
	else
	{
		%defNum = %numPlayers[%defTeam];
		%defCol = getColorIDTable(%mini.teamCol[%defTeam]);
	}
	
	%atkCol = getColorIDTable(%mini.teamCol[%atkTeam]);
	
	if(%atkTeam != %defTeam)
	{
		%brick.tdmCaptureNum[%atkTeam]+=2*%atkNum;
		%brick.tdmCaptureNum[%atkTeam]-=2*%defNum;
	}
	
	%brick.tdmCaptureNum[%atkTeam] = mClampF(%brick.tdmCaptureNum[%atkTeam],0,%brick.dataBlock.tdmCaptureHealth);
	
	%atkBar = getProgressBar(%brick.tdmCaptureNum[%atkTeam],
	%brick.dataBlock.tdmCaptureHealth,
	"<color:" @ RGBtoHEX(%atkCol) @ ">",
	"<color:" @ RGBtoHEX(%defCol) @ ">");
	%defBar = getProgressBar(%brick.dataBlock.tdmCaptureHealth-%brick.tdmCaptureNum[%atkTeam],
	%brick.dataBlock.tdmCaptureHealth,
	"<color:" @ RGBtoHEX(%defCol) @ ">",
	"<color:" @ RGBtoHEX(%atkCol) @ ">");
	
	for(%i=0;%i<%trigger.playerSet.getCount();%i++)
	{
		%obj = %trigger.playerSet.getObject(%i);
		%cl = %obj.client;
		if(%cl.minigame != %mini)
			continue;
		
		if(%cl.tdmTeam == %defTeam)
			%cl.bottomPrint(%defBar,2);
		else
			%cl.bottomPrint(%atkBar,2);
	}
	
	//Cannot occur on a 'Neutral' brick since team -1 can't capture back
	
	if(%brick.tdmCaptureNum[%atkTeam] == 0)
	{
		if(%brick.tdmIsCaptured)
			return;
		%brick.setTeamAllied(%defTeam+1,%defClient);
	}
	else if(%brick.tdmCaptureNum[%atkTeam] == %brick.dataBlock.tdmCaptureHealth)
	{
		if(%brick.tdmIsCaptured)
			return;
		%brick.setTeamAllied(%atkTeam+1,%atkClient);
	}
	else if(%brick.tdmIsCaptured)
	{
		%brick.tdmIsCaptured = 0;
		%colAv = vectorScale(vectorAdd(%atkCol,%defCol),0.5) SPC 1;
		%brick.setColor(getClosestPaintColor(%colAv));
	}
}

//Returns a string of coloured | symbols suitable for displaying in a bottomprint bar. Use %start and %sep as \cX or <color:> tags.
function getProgressBar(%a,%b,%start,%sep)
{ 
	%done = (%a >= %b) || (%a == 0);
	%end = (%a / %b) * 65;
	%str = (%a == 0 ? %sep : %start);
	
	for(%i=0;%i<65;%i++)
	{
		if(%i > %end && !%done)
		{
			%str = %str @ %sep;
			%done = 1;
		}
		%str = %str @ "|";
	}
	return %str;
}

//Events
registerOutputEvent(fxDTSBrick,"setTeamAllied","list NONE 0 PLAYER 7 1 1 2 2 3 3 4 4 5 5 6 6",1);
function fxDTSBrick::setTeamAllied(%this,%team,%client)
{
	if(%team == 7)
		%team = %client.tdmTeam+1;
	if(%team == 0)
		%team = "";
	%this.tdmAlliedTeam = %team;
	
	if(!%this.dataBlock.isTDMCapturePoint)
		return;
	
	if(!isObject(%this.getGroup().client.minigame))
		return;
	
	%mini = %this.getGroup().client.minigame;
	
	if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
		return;
	
	if(%team == 0 || !%mini.teamExists[%team-1] || %team > 3)
	{
		//A Capture Point can only be allied to nobody, team 0, team 1 or team 2
		%this.tdmAlliedTeam = "";
		
		%this.setColor(getClosestPaintColor("0.5 0.5 0.5 1"));
		%this.tdmCaptureNum0 = 0;
		%this.tdmCaptureNum1 = 0;
		%this.tdmCaptureNum2 = 0;
		%this.isCaptured = 1;
		%this.onTeamCaptureReset(%client);
		return;
	}
	
	%this.setColor(%mini.teamCol[%team-1]);
	%this.tdmIsCaptured = 1;
	%this.onTeamCapture(%team-1,%client);
	
	switch(%team)
	{
		case 1:
			%this.tdmCaptureNum0 = %this.dataBlock.tdmCaptureHealth;
			%this.tdmCaptureNum1 = 0;
			%this.tdmCaptureNum2 = 0;
		case 2:
			%this.tdmCaptureNum0 = 0;
			%this.tdmCaptureNum1 = %this.dataBlock.tdmCaptureHealth;
			%this.tdmCaptureNum2 = 0;
		case 3:
			%this.tdmCaptureNum0 = 0;
			%this.tdmCaptureNum1 = 0;
			%this.tdmCaptureNum2 = %this.dataBlock.tdmCaptureHealth;
	}
}

registerOutputEvent(GameConnection,"setTeam","list NONE -1 1 0 2 1 3 2 4 3 5 4 6 5",1);
function GameConnection::setTeam(%this,%team,%client)
{
	if(!isObject(%this.minigame))
		return;
	
	%mini = %this.minigame;
	
	if(!gameModeAttribute(%mini.gameMode,"UsesTeams"))
		return;
	if(%mini.gameAutoSort == 2)
		return;
	if(!%mini.teamExists[%team])
		%team = -1;
	if(%this.tdmTeam == %team)
		return;
	
	if(%team == -1)
		%mini.messageAll('',"\c3" @ %this.getPlayerName() @ "\c5 was removed from " @ teamName(%mini,%this.tdmteam) @ "\c5.");
	else
		%mini.messageAll('',"\c3" @ %this.getPlayerName() @ "\c5 was put into " @ teamName(%mini,%team) @ "\c5.");
	
	if(%mini.teamLeader[%this.tdmTeam] == %this)
		%mini.teamLeader[%this.tdmTeam] = "";
	
	%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientChangeTeam";
	if(isFunction(%f))
		call(%f,%mini,%this,%this.tdmTeam,%team);
	
	if(%mini.swapTeam[%this.tdmTeam] == %this)
	{
		cancel(%mini.swapSched[%this.tdmTeam]);
		%mini.swapTeam[%this.tdmTeam] = "";
		%mini.swapSched[%this.tdmTeam] = "";
	}
	
	%this.tdmTeam = %team;
	%this.instantRespawn();
}

registerOutputEvent(fxDTSBrick,"setTeamCapturable","list ALL -1 1 0 2 1 3 2" TAB "bool",1);
function fxDTSBrick::setTeamCapturable(%this,%team,%enable,%client)
{ 
	if(!%this.dataBlock.isTDMCapturePoint)
		return;
	
	if(!isObject(%this.getGroup().client.minigame))
		return;
	
	if(%team == -1)
	{
		%this.tdmPointCapturable[0] = %enable;
		%this.tdmPointCapturable[1] = %enable;
		%this.tdmPointCapturable[2] = %enable;
	}
	else
	{
		%this.tdmPointCapturable[%team] = %enable;
	}
}

if(isFile("Add-Ons/Event_Variables/description.txt") && $AddOn__Event_Variables == 1)
{
	forceRequiredAddOn("Event_Variables");
	
	RegisterSpecialVar(fxDTSBrick,"team","(%this.tdmAlliedTeam == 0 ? 0 : %this.tdmAlliedTeam)");
	
	RegisterSpecialVar(Vehicle,"team","(%this.spawnBrick.tdmAlliedTeam == 0 ? 0 : %this.spawnBrick.tdmAlliedTeam)");
	RegisterSpecialVar(Player,"team","(isObject(%this.client) ? %this.client.tdmTeam+1 : (%this.spawnBrick.tdmAlliedTeam == 0 ? 0 : %this.spawnBrick.tdmAlliedTeam))");
	
	RegisterSpecialVar(GameConnection,"team","%this.tdmTeam+1");
	RegisterSpecialVar(GameConnection,"teamLeader","(%this.minigame.teamLeader[%this.tdmTeam] == %this)");
	
	for(%i=0;%i<6;%i++)
		RegisterSpecialVar(MinigameSO,"team" @ %i+1 @ "Count","isObject(%this) ? %this.getTeamCount(" @ %i @ ") : 0");
	
	RegisterSpecialVar(MinigameSO,"roundTime","isObject(%this) ? %this.getTimeLimit() : 0");
}

function MinigameSO::getTeamCount(%this,%team)
{
	%count = 0;
	for(%i=0;%i<%this.numMembers;%i++)
	{
		if(%this.member[%i].tdmTeam == %team)
			%count++;
	}
	
	return %count;
}

package jvsInteractiveContent_Restriction_Teams
{
	//	Explanation of parameters sent to each method:
	//		%action: START or STOP, indicating whether usage this content brick is beginning or ending.
	//		%direction: CCW or CW, indicating whether this content brick is using the clockwise or counter-clockwise option.
	//		%text: The text entered in the box for this event in the events GUI.
	//		%client: The client attempting to use this content brick.
	
	function fxDTSBrick::contentTDMTeamAllowUse(%obj,%action,%direction,%text,%client)
	{
		%typeID = %obj.contentTypeID();
		
		if(%typeID > -1)
		{
			//This is a JVS brick, so continue with check.
			
			//Check for specially added +ID or -ID
			%blidPermission = contentBLIDCheck(%client,%text);
			if(%blidPermission != -1)
				return %blidPermission;
			
			//You are not in the owner's minigame
			if(miniGameCanUse(%client,%obj) != 1)
				return 0;
			
			%mini = getMinigameFromObject(%obj);
			
			for(%i=0;%i<getWordCount(%text);%i++)
			{
				%num = getWord(%text,%i);
				%char = getSubStr(%num,0,1);
				if(%char $= "+" || %char $= "-")
					continue;
				
				if(%num <= 0)
				{
					%string = %num;
					%num = -1;
					//Test the minigame for a text string
					for(%j=0;%j<6;%j++)
					{
						if(%mini.teamExists[%j] && %mini.teamName[%j] $= %string)
						{
							%num = %j;
							break;
						}
					}
				}
				else
				{
					%num--;
				}
				
				//You aren't in a TDM minigame, therefore "no team", and the Door allows people in no team, so allow
				if((!isObject(%mini) || !gameModeAttribute(%mini.gamemode,"UsesTeams")) && %num == -1)
					return 1;
				
				//You are in the specified team, so allow
				if(%client.tdmTeam == %num)
					return 1;
			}
			
			//You were not in any of the listed teams, so deny
			return 0;
		}
		else
		{
			//This is not a JVS special brick, so return invalid.
			return -1;
		}
	}
	
	function fxDTSBrick::contentTDMTeamDenyUse(%obj,%action,%direction,%text,%client)
	{
		%typeID = %obj.contentTypeID();
		
		if(%typeID > -1)
		{
			//This is a JVS brick, so continue with check.
			
			//Check for specially added +ID or -ID
			%blidPermission = contentBLIDCheck(%client,%text);
			if(%blidPermission != -1)
				return %blidPermission;
			
			//You are not in the owner's minigame
			if(miniGameCanUse(%client,%obj) != 1)
				return 0;
			
			%mini = getMinigameFromObject(%obj);
			
			for(%i=0;%i<getWordCount(%text);%i++)
			{
				%num = getWord(%text,%i);
				%char = getSubStr(%num,0,1);
				if(%char $= "+" || %char $= "-")
					continue;
				
				if(%num <= 0)
				{
					%string = %num;
					%num = -1;
					//Test the minigame for a text string
					for(%j=0;%j<6;%j++)
					{
						if(%mini.teamExists[%j] && %mini.teamName[%j] $= %string)
						{
							%num = %j;
							break;
						}
					}
				}
				else
				{
					%num--;
				}
				
				//You aren't in a TDM minigame, therefore "no team", and the Door denies people in no team, so deny
				if((!isObject(%mini) || !gameModeAttribute(%mini.gamemode,"UsesTeams")) && %num == -1)
					return 0;
				
				//You are in a denied team, so deny
				if(%client.tdmTeam == %num)
					return 0;
			}
			
			//You were not in any of the listed teams, so allow
			return 1;
		}
		else
		{
			//This is not a JVS special brick, so return invalid.
			return -1;
		}
	}
};

if(isFile("Add-Ons/JVS_Content/description.txt")) //like this instead of $Error::AddOn_NotFound since it causes a console error
{
	%error = ForceRequiredAddOn("JVS_Content");
	activatePackage(jvsInteractiveContent_Restriction_Teams);
	
	//Our restriction methods are created, so let's register each with JVS Content.
	//The first parameter is the name that should show up in the events GUI.
	//The second parameter is the name of the restriction method.
	//The third parameter is a unique ID
	ContentRestrictionsSO.addRestriction("TeamAllow","contentTDMTeamAllowUse","10100130");
	ContentRestrictionsSO.addRestriction("TeamDeny","contentTDMTeamDenyUse","10200130");
}

registerOutputEvent(MiniGame,"roundEnd","list CLIENT -1 1 0 2 1 3 2 4 3 5 4 6 5" TAB "bool",1);
function MiniGameSO::roundEnd(%this,%team,%swap,%client)
{
	if(%this.roundWon)
		return;
	
	if(isObject(%client) && %client.minigame != %this)
		return;
	
	if(!isObject(%client))
		%client = %this.owner;
	
	if(%team == -1 || !gameModeAttribute(%this.gameMode,"UsesTeams") || !%this.teamExists[%team])
	{
		%this.messageAll('',clientTeamName(%client,1) SPC "\c5won this round! Resetting in five seconds...");
		if(%client.tdmTeam == -1 || !%this.teamExists[%client.tdmTeam])
		{
			%client.tdmRoundsWon++;
			if(isObject(%client.player) && %client.player.getState() !$= "Dead")
				%client.player.emote(winStarProjectile,1);
			%client.play2d(rewardSound);
		}
		else
		{
			for(%i=0;%i<%this.numMembers;%i++)
			{
				%cl = %this.member[%i];
				if(%cl.tdmTeam == %client.tdmTeam)
				{
					if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
						%cl.player.emote(winStarProjectile,1);
					%cl.tdmRoundsWon++;
					%cl.play2d(rewardSound);
				}
			}
		}
	}
	else
	{
		%name = %this.teamName[%team];
		
		%s = (getSubStr(%name,strLen(%name)-1,1) $= "s");
		
		%this.messageAll('',(%s ? "\c5The " : "") @ teamName(%this,%team) @ " \c5win" @ (%s ? "" : "s") @ " this round! Resetting in five seconds...");
		for(%i=0;%i<%this.numMembers;%i++)
		{
			%cl = %this.member[%i];
			if(%cl.tdmTeam == %team)
			{
				if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
					%cl.player.emote(winStarProjectile,1);
				%cl.tdmRoundsWon++;
				%cl.play2d(rewardSound);
			}
		}
	}
	
	%this.roundWon = 1;
	%this.roundSwapTeams = (%swap && gameModeAttribute(%this.gameMode,"UsesTeams") && %this.teamExists[0] && %this.teamExists[1]);
	
	for(%i=0;%i<%this.numMembers;%i++)
	{
		%cl = %this.member[%i];
		if(isObject(%cl.player))
		{
			%cl.setControlObject(%cl.camera);
			%cl.camera.setMode("Corpse",%cl.player);
			%cl.tdmCameraTarget = 0;
		}
		else
		{
			%cl.getAutoCameraTarget();
		}
	}
	
	%this.schedule(5000,reset,%this.owner);
}

registerOutputEvent(MiniGame,"setTimeLimit","int 0 30 10",0);
registerOutputEvent(MiniGame,"addTimeLimit","int -30 30 5",0);

registerInputEvent(fxDTSBrick, "onTeam1PlayerTouch",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent(fxDTSBrick, "onTeam2PlayerTouch",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent(fxDTSBrick, "onTeam3PlayerTouch",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent(fxDTSBrick, "onTeam4PlayerTouch",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent(fxDTSBrick, "onTeam5PlayerTouch",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent(fxDTSBrick, "onTeam6PlayerTouch",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");

function fxDTSBrick::onTeamPlayerTouch(%obj, %player, %client, %team)
{
	//setup targets
	//client = player who touched it OR bot's spawnbrick owner
	//player = player who touched it OR bot who touched it
	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Player"] = %player;
	$InputTarget_["Client"] = %client;
	
	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
	}
	else
	{
		if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
		else
			$InputTarget_["MiniGame"] = 0;
	}
	//process the event
	%obj.processInputEvent("onTeam" @ %team+1 @ "PlayerTouch", %client);
}

registerInputEvent(fxDTSBrick, "onTeam1Capture",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent(fxDTSBrick, "onTeam2Capture",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent(fxDTSBrick, "onTeam3Capture",  "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");

function fxDTSBrick::onTeamCapture(%obj, %team, %client)
{
	//setup targets
	//player = person who captured it
	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	
	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
	}
	else
	{
		if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
		else
			$InputTarget_["MiniGame"] = 0;
	}
	//process the event
	%obj.processInputEvent("onTeam" @ %team+1 @ "Capture", %client);
}

registerInputEvent(fxDTSBrick, "onTeamCaptureReset",  "Self fxDTSBrick" TAB "MiniGame MiniGame");
//Only for Neutral capture points
function fxDTSBrick::onTeamCaptureReset(%obj, %client)
{
	//setup targets
	//player = person who captured it
	$InputTarget_["Self"]   = %obj;
	
	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
	}
	else
	{
		if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
		else
			$InputTarget_["MiniGame"] = 0;
	}
	//process the event
	%obj.processInputEvent("onTeamCaptureReset", %client);
}

//Detection of teamkills
addSpecialDamageMsg("Teamkill","%2%3%1 (Teamkill %4)","%3%1");
function isSpecialKill_Teamkill(%this,%sourceObject,%sourceClient,%mini)
{
	if(isObject(%mini) && gameModeAttribute(%mini.gamemode,"UsesTeams") && %sourceClient != %this && isObject(%sourceClient) && %sourceObject != 0)
	{
		%points = %mini.Points_TeamKill;
		if(%this.tdmTeam == %sourceClient.tdmTeam && %this.tdmTeam != -1 && %points != 0)
		{
			%sourceClient.incScore(-%mini.points_KillPlayer);
			%sourceClient.incScore(%points);
			
			%ret = (%points > 0 ? "+" : "") @ %points @ "pt" @ ((%points != 1 && %points != -1) ? "s" : "");
			return 2 TAB %ret;
		}
	}
	return 0;
}

//Show coloured death messages
addSpecialDamageMsg("TDMColor","%5%2%3%4%1","%3%4%1");
function isSpecialKill_TDMColor(%this,%sourceObject,%sourceClient,%mini)
{
	if(!isObject(%mini))
		return 0;
	
	if(!gameModeAttribute(%mini.gamemode,"UsesTeams"))
		return 0;
	
	if(%mini.tdmGeneralRule_SHOWNAMES)
	{
		if(%this.tdmTeam == -1 || !%mini.teamExists[%this.tdmTeam])
			%col1 = "\c0";
		else
			%col1 = "<color:" @ RGBToHEX(getColorIDTable(%mini.teamCol[%this.tdmTeam])) @ ">";
		
		if(%sourceClient.tdmTeam == -1 || !%mini.teamExists[%sourceClient.tdmTeam])
			%col2 = "\c0";
		else
			%col2 = "<color:" @ RGBToHEX(getColorIDTable(%mini.teamCol[%sourceClient.tdmTeam])) @ ">";
		
		return 2 TAB %col1 TAB %col2;
	}
	return 0;
}

//Packaged Functions
package TeamDeathmatch
{
	function GameConnection::instantrespawn(%this)
	{
		if(isObject(%this.minigame) && %this.minigame.tdmLivesLimit > 0 && %this.tdmLives <= 0)
			return;
		Parent::instantrespawn(%this);
	}
	function GameConnection::incScore(%this,%score)
	{
		Parent::incScore(%this,%score);
		
		if(isObject(%this.minigame) && %this.minigame.tdmPointsLimit > 0)
		{
			%this.minigame.checkPointsLimit();
		}
	}
	function GameConnection::setScore(%this,%score)
	{
		Parent::setScore(%this,%score);
		
		if(isObject(%this.minigame) && %this.minigame.tdmPointsLimit > 0)
		{
			%this.minigame.checkPointsLimit();
		}
	}
	function GameConnection::onClientEnterGame(%this)
	{
		Parent::onClientEnterGame(%this);
		%client.hasTeamDM = 0;
		commandtoclient(%this,'teamDMServerConfirm');
	}
	function servercmdrequestTDMGameModes(%client)
	{
		%client.hasTeamDM = 1;
		
		for(%i=0;%i<=GameModeStorerSO.modeCount;%i++)
		{
			commandtoclient(%client,'registerGameMode',gameModeIDToTitle(%i),gameModeAttribute(%i,"UsesTeams"),gameModeAttribute(%i,"SpecialTeams"));
			
			for(%j=0;%j<GameModeStorerSO.modeRuleCount[%i];%j++)
				commandtoclient(%client,'addGameModeRule',gameModeIDToTitle(%i),GameModeStorerSO.modeRuleTxt[%i,%j],GameModeStorerSO.modeRuleStr[%i,%j],GameModeStorerSO.modeRuleDef[%i,%j]);
			
			%text = GameModeStorerSO.modeHelp[%i];
			for(%j=0;%j<getLineCount(%text);%j++)
			{
				commandtoclient(%client,'addGameModeHelp',gameModeIDToTitle(%i),getLine(%text,%j));
			}
		}
		for(%j=0;%j<GameModeStorerSO.modeRuleCount[-1];%j++)
			commandtoclient(%client,'addGeneralRule',GameModeStorerSO.modeRuleTxt[-1,%j],GameModeStorerSO.modeRuleStr[-1,%j],GameModeStorerSO.modeRuleDef[-1,%j]);
	}
	function servercmdrequestTDMPlayerList(%client)
	{
		if(!%client.hasTeamDM)
			return;
		
		commandtoclient(%client,'clearteamDMplayerdata');
		
		if(!isObject(%client.minigame))
		{
			commandtoclient(%client,'teamDMplayerdata',-1,($Server::LAN),0,0);
			return;
		}
		
		if(%client.minigame.owner != %client)
			return;
		
		for(%i=0;%i<%client.minigame.numMembers;%i++)
		{
			%o = %client.minigame.member[%i];
			commandtoclient(%client,'teamDMplayerdata',%i,%o.getPlayerName(),(%client.minigame.teamExists[%o.tdmTeam] ? %client.minigame.teamName[%o.tdmTeam] : "NONE"),(%client.minigame.teamLeader[%o.tdmTeam] == %o));
		}
	}
	function servercmdrequestTDMTeamList(%client)
	{
		if(!%client.hasTeamDM)
			return;
		
		if(!isObject(%client.minigame))
			return;
		
		if(%client.minigame.owner != %client)
			return;
		
		%mini = %client.minigame;
		
		for(%i=0;%i<6;%i++)
		{
			if(%mini.teamExists[%i])
			{
				commandtoclient(%client,'teamDMteamdata',%i,1,%mini.teamName[%i],%mini.teamCol[%i]);
			}
			else
			{
				commandtoclient(%client,'teamDMteamdata',%i,0,"",-1);
			}
		}
	}
	function servercmdtdmRequestModeSpecial(%client,%mode)
	{
		if((getSimTime() - %client.lastTDMDataTime) < 500)
			return;
		%client.lastTDMDataTime = getSimTime();
		if(!gameModeAttribute(%mode,"SpecialTeams"))
			return;
		
		%f = "GameMode_" @ gameModeAttribute(%mode,"ShortTitle") @ "_GetSpecialTeams";
		if(isFunction(%f))
			call(%f,%client);
	}
	function fxDTSBrick::onPlant(%this)
	{
		Parent::onPlant(%this);
		
		if(%this.dataBlock.tdmSetAllied !$= "")
		{
			%data = %this.dataBlock;
			%this.schedule(1,setTeamAllied,%data.tdmSetAllied);
		}
		
		if(isObject(%this.getGroup()) && %this.dataBlock.isTDMBrick)
			%this.getGroup().addTDMBrick(%this);
		
		if(%this.dataBlock.isTDMCapturePoint)
		{
			%this.createTriggerZone(TDMPointTriggerData);
			if(isObject(%this.triggerZone))
			{
				%this.triggerZone.playerSet = new SimSet();
			}
			%this.setTeamCapturable(-1,1);
		}
	}
	function fxDTSBrick::onRemove(%this)
	{
		if(isObject(%this.getGroup()) && %this.dataBlock.isTDMBrick)
			%this.getGroup().removeTDMBrick(%this);
		
		if(%this.dataBlock.isTDMCapturePoint)
		{
			if(isObject(%this.triggerZone.playerSet))
				%this.triggerZone.playerSet.delete();
			
			if(isObject(%this.triggerZone))
				%this.triggerZone.delete();
		}
		
		Parent::onRemove(%this);
	}
	function fxDTSBrick::createTriggerZone(%brick,%triggerData)
	{
		if(!isObject(%triggerData))
		{
			error("ERROR: Trigger data \"" @ %triggerData @ "\" does not exist for " @ %brick.dataBlock.getName() @ " brick!");
			return;
		}
		if(%triggerData.getClassName() !$= "TriggerData")
		{
			error("ERROR: \"" @ %triggerData @ "\" is not a TriggerData datablock!");
			return;
		}
		
		%t = new Trigger()
		{
			dataBlock = %triggerData;
			polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1";
		};
		if(!isObject(%t))
		{
			error("ERROR: Could not create trigger for " @ %brick.dataBlock.getName() @ " brick!");
			return;
		}
		missionCleanup.add(%t);
		
		//The trigger is made slightly larger than the brick and offset
		%boxMin = getWords(%brick.getWorldBox(), 0, 2);
		%boxMax = getWords(%brick.getWorldBox(), 3, 5);
		%boxDiff = vectorSub(%boxMax, %boxMin);
		%boxDiff = vectorAdd(%boxDiff, "0 0 0.2"); 
		%t.setScale(%boxDiff);
		
		%posA = %brick.getWorldBoxCenter();
		%posB = %t.getWorldBoxCenter();
		%posDiff = vectorSub(%posA, %posB);
		%posDiff = vectorAdd(%posDiff, "0 0 0.1");
		%t.setTransform(%posDiff);
		
		%brick.triggerZone = %t;
		%t.spawnBrick = %brick;
	}
	function fxDTSBrick::onPlayerTouch(%this,%player)
	{
		Parent::onPlayerTouch(%this,%player);
		if(isObject(%player.client))
		{
			%client = %player.client;
			%team = %client.tdmTeam;
		}
		else if(%player.getClassName() $= "AIPlayer" && isObject(%player.spawnBrick))
		{
			%client = %player.spawnBrick.getGroup().client;
			%team = %player.spawnBrick.tdmAlliedTeam-1;
		}
		else
			return;
		
		if(isObject(%client.minigame) && gameModeAttribute(%client.minigame.gamemode,"UsesTeams") && %team != -1)
		{
			%this.onTeamPlayerTouch(%player,%client,%team);
		}
	}
	function SimGroup::addTDMBrick(%this,%brick)
	{
		if(!isObject(%brick))
			return;
		
		if(%this.tdmBrickCount $= "")
			%this.tdmBrickCount = 0;
		
		%this.tdmBrick[%this.tdmBrickCount] = %brick;
		%this.tdmBrickCount++;
	}
	function SimGroup::removeTDMBrick(%this,%brick)
	{
		//I can't remember the better way for doing this right now
		for(%i=0;%this.tdmBrick[%i] !$= "";%i++)
		{
			if(%this.tdmBrick[%i] == %brick)
			{
				for(%j=%i;%this.tdmBrick[%j] !$= "";%j++)
				{
					%this.tdmBrick[%j] = %this.tdmBrick[%j+1];
				}
				%this.tdmBrickCount--;
			}
		}
	}
	function MinigameSO::onAdd(%this)
	{
		//I should be calling this, but it creates an error for some reason...
		
		//Parent::onAdd(%this);
		%this.schedule(60000,displayModeScores);
	}
	function MinigameSO::addMember(%this,%client)
	{
		%client.tdmTeam = -1;
		%client.tdmRoundsWon = 0;
		
		if(%this.tdmLivesLimit > 0)
		{
			%client.tdmLives = %this.tdmLivesLimit;
			messageClient(%client,'',"\c5You have \c3" @ %this.tdmLivesLimit @ "\c5 " @ (%this.tdmLivesLimit == 1 ? "life" : "lives") @ " remaining.");
		}
		
		if(gameModeAttribute(%this.gamemode,"UsesTeams"))
		{
			%team = %this.pickAutoSortTeam();
			
			if(%this.gameAutoSort == 1)
				%client.tdmTeam = %team;
			else
				%client.tdmTeam = -1;
			
			%ret = Parent::addMember(%this,%client);
			
			if(%this.gameAutoSort == 1 && %team != -1)
				%this.messageAll('',"\c3" @ %client.getPlayerName() @ "\c5 was put into " @ teamName(%this,%client.tdmTeam) @ "\c5. (Auto Sort)");
			
			if(%this.gameAutoSort == 2)
				%this.sortMemberTeams("(Auto Sort)");
		}
		else
			%ret = Parent::addMember(%this,%client);
		
		servercmdrequestTDMPlayerList(%this.owner);
		
		%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_onAddMember";
		if(isFunction(%f))
			call(%f,%this,%client);
		
		if(%this.tdmHelpShow)
			servercmdmodehelp(%client);
		
		return %ret;  
	}
	function MinigameSO::removeMember(%this,%client)
	{
		%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_onRemoveMember";
		if(isFunction(%f))
			call(%f,%this,%client);
		
		%client.tdmTeam = -1;
		%client.tdmRoundsWon = 0;
		
		%ret = Parent::removeMember(%this,%client);
		
		if(%this.gameAutoSort == 2)
			%this.sortMemberTeams("(Auto Sort)");
		
		servercmdrequestTDMPlayerList(%mini.owner);
		
		return %ret;
	}
	
	function MinigameSO::pickSpawnPoint(%this,%client)
	{
		%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_pickSpawnPoint";
		if(isFunction(%f))
			%val = call(%f,%this,%client);
		
		if(%val !$= "")
			return %val;
		
		if(!%this.useSpawnBricks || !gameModeAttribute(%this.gamemode,"usesTeams"))
			return Parent::pickSpawnPoint(%this,%client);
		
		%numList = -1;
		
		//Look for all normal spawn points and all Team DM spawn points - if you've used setTeamAllied on them either may be a valid spawn
		if(%this.useAllPlayersBricks)
		{
			for(%i=0;%i<%this.numMembers;%i++)
			{
				%group = %this.member[%i].brickGroup;
				if(isObject(%group))
				{
					for(%j=0;%j<%group.spawnBrickCount;%j++)
					{
						%o = %group.spawnBrick[%j];
						if(%o.getDatablock().specialBrickType $= "SpawnPoint" && ((%o.tdmAlliedTeam == (%client.tdmTeam+1) && %client.tdmTeam > -1) || (%o.tdmAlliedTeam $= "" && %client.tdmTeam == -1)) && !%o.isDead())
						{
							%list[%numList++] = %o;
						}
					}
					for(%j=0;%j<%group.tdmBrickCount;%j++)
					{
						%o = %group.tdmBrick[%j];
						if(%o.getDatablock().specialBrickType $= "SpawnPoint" && ((%o.tdmAlliedTeam == (%client.tdmTeam+1) && %client.tdmTeam > -1) || (%o.tdmAlliedTeam $= "" && %client.tdmTeam == -1)) && !%o.isDead())
						{
							%list[%numList++] = %o;
						}
					}
				}
			}
		}
		else
		{
			%group = %this.owner.brickGroup;
			if(isObject(%group))
			{
				for(%j=0;%j<%group.spawnBrickCount;%j++)
				{
					%o = %group.spawnBrick[%j];
					if(%o.getDatablock().specialBrickType $= "SpawnPoint" && ((%o.tdmAlliedTeam == (%client.tdmTeam+1) && %client.tdmTeam > -1) || (%o.tdmAlliedTeam $= "" && %client.tdmTeam == -1)) && !%o.isDead())
					{
						%list[%numList++] = %o;
					}
				}
				for(%j=0;%j<%group.tdmBrickCount;%j++)
				{
					%o = %group.tdmBrick[%j];
					if(%o.getDatablock().specialBrickType $= "SpawnPoint" && ((%o.tdmAlliedTeam == (%client.tdmTeam+1) && %client.tdmTeam > -1) || (%o.tdmAlliedTeam $= "" && %client.tdmTeam == -1)) && !%o.isDead())
					{
						%list[%numList++] = %o;
					}
				}
			}
		}
		
		if(%numList == -1)
			return pickSpawnPoint();
		else
			return %list[getRandom(0,%numList)].getSpawnTransform();
	}
	
	function MinigameSO::updatePlayerDatablock(%this)
	{    
		if(gameModeAttribute(%this.gamemode,"usesTeams"))
		{
			for(%i=0;%i<%this.numMembers;%i++)
			{
				%cl = %this.member[%i];
				if(isObject(%cl.player) && (%cl.tdmTeam == -1 || !%this.teamExists[%cl.tdmTeam]))
					%cl.player.setDatablock(%this.playerDatablock);
			}
		}
		else
			%ret = Parent::updatePlayerDatablock(%this);
		
		%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_updatePlayerDatablock";
		if(isFunction(%f))
			call(%f,%this);
		
		return %ret;
	}
	
	function MinigameSO::forceEquip(%this,%slot)
	{
		%tool = (isObject(%this.startEquip[%slot]) ? %this.startEquip[%slot].getID() : 0);
		
		if(gameModeAttribute(%this.gamemode,"usesTeams"))
		{
			for(%i=0;%i<%this.numMembers;%i++)
			{
				%cl = %this.member[%i];
				if(isObject(%cl.player) && (%cl.tdmTeam == -1 || !%this.teamExists[%cl.tdmTeam]))
				{
					%cl.player.tool[%slot] = %tool;
					messageClient(%cl,'MsgItemPickup',"",%slot,%tool,1);
					if(%cl.player.currTool == %slot)
					{
						if(%tool != 0)
							servercmdUseTool(%cl,%slot);
						else
							servercmdUnUseTool(%cl);
					}
				}
			}
		}
		else
			%ret = Parent::forceEquip(%this,%slot);
		
		%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_forceEquip";
		if(isFunction(%f))
			call(%f,%this,%slot);
	}
	
	function MinigameSO::reset(%this,%client)
	{
		%this.tdmResetCheck = 1;
		%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_onMiniReset";
		if(isFunction(%f))
			call(%f,%this,%client);
		
		if(%this.roundSwapTeams)
		{
			%this.roundSwapTeams = 0;
			%this.sortMemberOffset = (%this.sortMemberOffset + 1) % 100000;
			%this.sortMemberTeams("");
		}
		
		Parent::reset(%this,%client);
		
		%this.roundWon = 0;
		
		%this.resetCapturePoints(); //doing this beforehand cancels all onTeamXCapture events!
		%this.tdmResetCheck = 0;
	}
	
	function MinigameSO::endGame(%this)
	{
		%this.resetCapturePoints();
		%f = "GameMode_" @ gameModeAttribute(%this.gamemode,"ShortTitle") @ "_onModeEnd";
		if(isFunction(%f))
			call(%f,%this);
		
		%this.owner.tdmTeam = -1;
		
		Parent::endGame(%this,%client);
	}
	
	function servercmdTeamMessageSent(%client,%msg)
	{
		if(getSimTime() - %client.spamProtectStart < 10000)
			return Parent::servercmdTeamMessageSent(%client,%msg);
		
		//If you aren't in a team/team minigame, do normal team chat
		if(!isObject(%client.minigame))
			return Parent::servercmdTeamMessageSent(%client,%msg);
		
		if(!%client.minigame.tdmGeneralRule_DEADTALK && %client.tdmTeam == -1 && ((!isObject(%client.player) || %client.player.getState() $= "Dead") || %client.isSpectator()))
			return servercmdMessageSent(%client,%msg);
		
		//Remove <bitmap>, <br>, \cX, etc.
		%temp = stripMLControlChars(%msg);
		while(%temp !$= %msg)
		{
			%msg = %temp;
			%temp = stripMLControlChars(%msg);
		}
		
		%msg = trim(%temp);
		if(%msg $= "")
			return;
		
		if($Pref::Server::FloodProtectionEnabled && !%client.isAdmin && !%client.isSuperAdmin)
		{
			if(getSimTime() - %client.lastChatTime < 2000)
			{
				%client.spamMessageCount++;
				if(%client.spamMessageCount >= 4)
				{
					Parent::servercmdMessageSent(%client,%msg);
					return;
				}
			}
			else
				%client.spamMessageCount = 0;
		}
		%client.lastChatTime = getSimTime();
		
		if(!gameModeAttribute(%client.minigame.gamemode,"UsesTeams"))
			return Parent::servercmdTeamMessageSent(%client,%msg);
		
		if(%client.tdmTeam == -1)
			return Parent::servercmdTeamMessageSent(%client,%msg);
		
		if(!%client.minigame.gameTeamChat)
			return Parent::servercmdTeamMessageSent(%client,%msg);
		
		//Create message
		%message = "\c7" @ %client.clanPrefix @ "\c3" @ %client.getPlayerName() @ "\c7" @ %client.clanSuffix;
		%message = %message SPC "\c7[" @ teamName(%client.minigame,%client.tdmTeam);
		%message = %message @ (%client.minigame.teamLeader[%client.tdmTeam] == %client ? " Leader" : "");
		%message = %message @ "\c7]\c4:" SPC %msg;
		
		if(%client.minigame.roundWon)
		{
			//Repeat Flood Protection
			if(%client.lastTeamChatText $= %msg)
			{
				if($Pref::Server::FloodProtectionEnabled && !%client.isAdmin && !%client.isSuperAdmin)
				{
					%client.spamMessageCount = 4;
					Parent::servercmdMessageSent(%client,%msg);
					return;
				}
				else
					messageClient(%client,'',"\c5Do not repeat yourself.");
			}
			%client.lastTeamChatText = %msg;
			
			//Display message
			if($SpaceMods::Server::TeamDM::EchoChat)
				echo("(T:" @ %client.minigame.teamName[%client.tdmTeam] @ ")" SPC %client.getPlayerName() @ ": " @ %msg);
			for(%i=0;%i<%client.minigame.numMembers;%i++)
			{
				%cl = %client.minigame.member[%i];
				if(%cl.tdmTeam == %client.tdmTeam)
					messageClient(%cl,'',%message);
			}
		}
		else if((!isObject(%client.player) || %client.player.getState() $= "Dead") && !%client.minigame.tdmGeneralRule_DEADTALK)
		{
			//Repeat Flood Protection
			if(%client.lastDeadTeamChatText $= %msg)
			{
				if($Pref::Server::FloodProtectionEnabled && !%client.isAdmin && !%client.isSuperAdmin)
				{
					%client.spamMessageCount = 4;
					Parent::servercmdMessageSent(%client,%msg);
					return;
				}
				else
					messageClient(%client,'',"\c5Do not repeat yourself.");
			}
			%client.lastDeadTeamChatText = %msg;
			
			%message = "<color:BBBBBB>*DEAD*" SPC %message;
			
			//Display message
			if($SpaceMods::Server::TeamDM::EchoChat)
				echo("(DEAD T:" @ %client.minigame.teamName[%client.tdmTeam] @ ")" SPC %client.getPlayerName() @ ": " @ %msg);
			for(%i=0;%i<%client.minigame.numMembers;%i++)
			{
				%cl = %client.minigame.member[%i];
				if((!isObject(%cl.player) || %cl.player.getState() $= "Dead" || %cl.isSpectator()) && %cl.tdmTeam == %client.tdmTeam)
					messageClient(%cl,'',%message);
			}
		}
		else if(%client.isSpectator() && !%client.minigame.tdmGeneralRule_DEADTALK)
		{
			//Repeat Flood Protection
			if(%client.lastDeadTeamChatText $= %msg)
			{
				if($Pref::Server::FloodProtectionEnabled && !%client.isAdmin && !%client.isSuperAdmin)
				{
					%client.spamMessageCount = 4;
					Parent::servercmdMessageSent(%client,%msg);
					return;
				}
				else
					messageClient(%client,'',"\c5Do not repeat yourself.");
			}
			%client.lastDeadTeamChatText = %msg;
			
			%message = "<color:BBBBBB>*SPEC*" SPC %message;
			
			//Display message
			if($SpaceMods::Server::TeamDM::EchoChat)
				echo("(SPEC T:" @ %client.minigame.teamName[%client.tdmTeam] @ ")" SPC %client.getPlayerName() @ ": " @ %msg);
			for(%i=0;%i<%client.minigame.numMembers;%i++)
			{
				%cl = %client.minigame.member[%i];
				if((!isObject(%cl.player) || %cl.player.getState() $= "Dead" || %cl.isSpectator()) && %cl.tdmTeam == %client.tdmTeam)
					messageClient(%cl,'',%message);
			}
		}
		else
		{
			//Repeat Flood Protection
			if(%client.lastTeamChatText $= %msg)
			{
				if($Pref::Server::FloodProtectionEnabled && !%client.isAdmin && !%client.isSuperAdmin)
				{
					%client.spamMessageCount = 4;
					Parent::servercmdMessageSent(%client,%msg);
					return;
				}
				else
					messageClient(%client,'',"\c5Do not repeat yourself.");
			}
			%client.lastTeamChatText = %msg;
			
			//Display message
			if($SpaceMods::Server::TeamDM::EchoChat)
				echo("(T:" @ %client.minigame.teamName[%client.tdmTeam] @ ")" SPC %client.getPlayerName() @ ": " @ %msg);
			for(%i=0;%i<%client.minigame.numMembers;%i++)
			{
				%cl = %client.minigame.member[%i];
				if(%cl.tdmTeam == %client.tdmTeam)
					messageClient(%cl,'',%message);
			}
		}
	}
	
	function servercmdMessageSent(%client,%msg)
	{
		if(getSimTime() - %client.spamProtectStart < 10000)
			return Parent::servercmdMessageSent(%client,%msg);
		
		//If you aren't in a team/team minigame, do normal team chat
		if(!isObject(%client.minigame))
			return Parent::servercmdMessageSent(%client,%msg);
		
		if(%client.minigame.tdmGeneralRule_DEADTALK)
			return Parent::servercmdMessageSent(%client,%msg);
		
		if((isObject(%client.player) && %client.player.getState() !$= "Dead") && !%client.isSpectator())
			return Parent::servercmdMessageSent(%client,%msg);
		
		if(%client.minigame.roundWon)
			return Parent::servercmdMessageSent(%client,%msg);
		
		//Remove <bitmap>, <br>, \cX, etc.
		%temp = stripMLControlChars(%msg);
		while(%temp !$= %msg)
		{
			%msg = %temp;
			%temp = stripMLControlChars(%msg);
		}
		
		%msg = trim(%temp);
		if(%msg $= "")
			return;
		
		//Repeat Flood Protection
		if(%client.lastDeadChatText $= %msg)
		{
			if($Pref::Server::FloodProtectionEnabled && !%client.isAdmin && !%client.isSuperAdmin)
			{
				%client.spamMessageCount = 4;
				Parent::servercmdMessageSent(%client,%msg);
				return;
			}
			else
				messageClient(%client,'',"\c5Do not repeat yourself.");
		}
		%client.lastDeadChatText = %msg;
		
		//Count Flood Protection
		if($Pref::Server::FloodProtectionEnabled && !%client.isAdmin && !%client.isSuperAdmin)
		{
			if(getSimTime() - %client.lastChatTime < 2000)
			{
				%client.spamMessageCount++;
				if(%client.spamMessageCount >= 4)
				{
					Parent::servercmdMessageSent(%client,%msg);
					return;
				}
			}
			else
				%client.spamMessageCount = 0;
		}
		%client.lastChatTime = getSimTime();
		
		//Create message		
		%message = "\c7" @ %client.clanPrefix @ "\c3" @ %client.getPlayerName() @ "\c7" @ %client.clanSuffix;
		%message = %message @ "<color:BBBBBB>:" SPC %msg;
		
		//Display message
		if(!isObject(%client.player) || %client.player.getState() $= "Dead")
		{
			%message = "<color:BBBBBB>*DEAD*" SPC %message;
			if($SpaceMods::Server::TeamDM::EchoChat)
				echo("(DEAD)" SPC %client.getPlayerName() @ ": " @ %msg);
		}
		else
		{
			%message = "<color:BBBBBB>*SPEC*" SPC %message;
			if($SpaceMods::Server::TeamDM::EchoChat)
				echo("(SPEC)" SPC %client.getPlayerName() @ ": " @ %msg);
		}
		
		for(%i=0;%i<%client.minigame.numMembers;%i++)
		{
			%cl = %client.minigame.member[%i];
			if(!isObject(%cl.player) || %cl.player.getState() $= "Dead" || %cl.isSpectator())
				messageClient(%cl,'',%message);
		}
	}
	
	function servercmdSetMinigameData(%client,%datastring)
	{
		Parent::servercmdSetMinigameData(%client,%datastring);
		if(!isObject(%client.minigame) || %client.minigame.owner != %client)
			return;
		
		%mini = %client.minigame;
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onMinigameUpdateSettings";
		if(isFunction(%f))
			call(%f,%mini,%client,%datastring);
	}
	
	function miniGameCanDamage(%obj1,%obj2)
	{
		if(!isObject(%obj1) || !isObject(%obj2))
			return Parent::miniGameCanDamage(%obj1,%obj2);
		
		%val = Parent::miniGameCanDamage(%obj1,%obj2);
		if(%val != 1)
			return %val;
		switch$(%obj1.getClassName())
		{
			case "Player":
				%cl1 = %obj1.client;
			case "AIPlayer":
				if(isObject(%obj1.client))
					%cl1 = %obj1.client;
				else if(isObject(%obj1.spawnBrick) && isObject(%obj1.spawnBrick.getGroup().client))
				{
					%cl1 = (isObject(%obj1.spawnBrick.getGroup().client) ? %obj1.spawnBrick.getGroup().client : -1);
					%mini = %cl1.minigame;
					%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_miniGameCanDamage";
					if(isFunction(%f))
					{
						%val = call(%f,%mini,%obj1,%obj2,%cl1,%cl1);
						if(%val !$= "")
							return %val;
					}
					return (%mini.vehicleDamage == 1);
				}
				else
					%cl1 = -1;
			case "Projectile":
				%cl1 = %obj1.client;
			case "AIConnection":
				%cl1 = %obj1;
			case "GameConnection":
				%cl1 = %obj1;
			case "fxDTSBrick":
				return 1;
		}
		
		if(%obj1.getType() & $TypeMasks::VehicleObjectType)
		{
			%cl1 = (isObject(%obj1.spawnBrick.getGroup().client) ? %obj1.spawnBrick.getGroup().client : -1);
			%mini = %cl1.minigame;
			%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_miniGameCanDamage";
			if(isFunction(%f))
			{
				%val = call(%f,%mini,%obj1,%obj2,%cl1,%cl1);
				if(%val !$= "")
					return %val;
			}
			return (%mini.vehicleDamage == 1);
		}
		else
			%team1 = %cl1.tdmTeam;
		
		if(%team1 $= "")
			%team1 = -1;
		
		switch$(%obj2.getClassName())
		{
			case "Player":
				%cl2 = %obj2.client;
			case "AIPlayer":
				if(isObject(%obj2.client))
					%cl2 = %obj2.client;
				else if(isObject(%obj2.spawnBrick) && isObject(%obj2.spawnBrick.getGroup().client))
				{
					%cl2 = (isObject(%obj2.spawnBrick.getGroup().client) ? %obj2.spawnBrick.getGroup().client : -1);
					%mini = %cl1.minigame;
					%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_miniGameCanDamage";
					if(isFunction(%f))
					{
						%val = call(%f,%mini,%obj1,%obj2,%cl1,%cl2);
						if(%val !$= "")
							return %val;
					}
					return (%mini.vehicleDamage == 1);
				}
				else
					%cl2 = -1;
			case "Projectile":
				%cl2 = %obj2.client;
			case "AIConnection":
				%cl1 = %obj1;
			case "GameConnection":
				%cl2 = %obj2;
			case "fxDTSBrick":
				return 1;
		}
		
		if(%obj2.getType() & $TypeMasks::VehicleObjectType)
		{
			%cl2 = (isObject(%obj2.spawnBrick.getGroup().client) ? %obj2.spawnBrick.getGroup().client : -1);
			%mini = %cl1.minigame;
			%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_miniGameCanDamage";
			if(isFunction(%f))
			{
				%val = call(%f,%mini,%obj1,%obj2,%cl1,%cl2);
				if(%val !$= "")
					return %val;
			}
			return (%mini.vehicleDamage == 1);
		}
		else
			%team2 = %cl2.tdmTeam;
		
		if(%team2 $= "")
			%team2 = -1;
		
		//We know that they are in the same minigame from the %val part at the top
		//We do need all the code to have been run to determine which minigame it is, though
		
		%mini = %cl1.minigame;
		//echo(%mini SPC localclientconnection.minigame);
		//if(%mini == localclientconnection.minigame)
		//	echo("CHECK");
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_miniGameCanDamage";
		if(isFunction(%f))
		{
			%val = call(%f,%mini,%obj1,%obj2,%cl1,%cl2);
			if(%val !$= "")
				return %val;
		}
		
		if(%cl1 == %cl2)
			return %mini.selfDamage;
		
		if(!%cl1.minigame.gameFriendlyFire && isObject(%cl1) && isObject(%cl2) && %cl1.tdmTeam == %cl2.tdmTeam && %cl1.tdmTeam != -1)
			return 0;
		else
			return 1;
	}
	
	function miniGameCanUse(%obj1,%obj2)
	{
		%mini1 = getMinigameFromObject(%obj1);
		%mini2 = getMinigameFromObject(%obj1);
		if(%mini1 != %mini2 || %mini1 == -1)  
			return Parent::miniGameCanUse(%obj1,%obj2);
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_miniGameCanUse";
		if(isFunction(%f))
		{
			%val = call(%f,%mini1,%obj1,%obj2);
			if(%val !$= "")
				return %val;
		}
		
		return Parent::miniGameCanUse(%obj1,%obj2);
	}
	
	//I would have put this code in miniGameCanUse() but it gives odd messages and flickering for "Space Guy does not trust you enough to use this vehicle" when I do and am in the same minigame
	function WheeledVehicleData::onCollision(%this, %obj, %col, %pos, %vel)
	{
		%mini = 0;
		if($Server::LAN)
		{
			if(isObject(%col.client) && isObject(getMinigameFromObject(%col)))
				%mini = 1;
		}
		else
		{
			if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%col) && isObject(getMinigameFromObject(%col)))
				%mini = 1;
		}
		
		if(%mini)
		{
			if(%this.numMountPoints > 0 && isObject(%obj.spawnBrick) && %obj.spawnBrick.tdmAlliedTeam !$= "") //using a vehicle with team
			{
				if(%col.getType() & $TypeMasks::PlayerObjectType && isObject(%col.client) && vectorLen(%obj.getVelocity()) < %this.minRunOverSpeed) //player with team, getting into vehicle
				{
					if(%obj.spawnBrick.tdmAlliedTeam-1 != %col.client.tdmTeam)
					{
						if(%col.client.getClassName() $= "GameConnection") //only send the message to real clients
							%col.client.schedule(0,centerPrint,"\c5Only members of " @ teamName(getMinigameFromObject(%col),%obj.spawnBrick.tdmAlliedTeam-1) @ "\c5 can use this \c3" @ trim(%this.uiName) @ "\c5.",2);
						return;
					}
				}
			}
		}
		return Parent::onCollision(%this, %obj, %col, %pos, %vel);
	}
	
	function Armor::onCollision(%this, %obj, %col, %pos, %vel)
	{
		%mini = 0;
		if($Server::LAN)
		{
			if(isObject(%col.client) && isObject(getMinigameFromObject(%col)))
				%mini = 1;
		}
		else
		{
			if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%col))
				%mini = 1;
		}
		
		if(%mini)
		{
			if(%this.numMountPoints > 0 && isObject(%obj.spawnBrick) && %obj.spawnBrick.tdmAlliedTeam !$= "") //using a vehicle with team
			{
				if(%col.getType() & $TypeMasks::PlayerObjectType && isObject(%col.client)) //player with team
				{
					if(%obj.spawnBrick.tdmAlliedTeam-1 != %col.client.tdmTeam)
					{
						if(%col.client.getClassName() $= "GameConnection") //only send the message to real clients
							%col.client.schedule(0,centerPrint,"\c5Only members of " @ teamName(getMiniGameFromObject(%col),%obj.spawnBrick.tdmAlliedTeam-1) @ "\c5 can use this \c3" @ trim(%this.uiName) @ "\c5.",2);
						return;
					}
				}
			}
		}
		return Parent::onCollision(%this, %obj, %col, %pos, %vel);
	}
	
	function GameConnection::onDeath(%this,%sourceObject,%sourceClient,%damageType,%damageArea)
	{
		if(isObject(%this.minigame))
		{
			%mini = %this.minigame;
			%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientDeath";
			if(isFunction(%f))
				call(%f,%mini,%this,%sourceObject,%sourceClient,%damageType,%damageArea);
			
			if(%mini.tdmLivesLimit)
			{
				%this.tdmLives--;
				if(%this.tdmLives <= 0)
				{
					%this.tdmLives = 0;
					%this.tdmCameraTarget = -1;
					%this.tdmCameraSched = %this.schedule(2000,getAutoCameraTarget); //a second after the body disappears it switches if possible
					%dead = 1;
				}
			}
			
			for(%i=0;%i<%mini.numMembers;%i++)
			{
				%cl = %mini.member[%i];
				if(%cl.tdmLives <= 0 && %mini.member[%cl.tdmCameraTarget] == %this && %cl.camera.mode $= "Corpse")
				{
					%cl.tdmCameraSched = %cl.schedule(6000,getAutoCameraTarget);
				}
			}
			
			if(%mini.getForceRespawn(%this))
				%this.schedule(%mini.respawnTime,instantRespawn);
		}
		
		Parent::onDeath(%this,%sourceObject,%sourceClient,%damageType,%damageArea);
		
		if(%dead)
		{
			messageClient(%this,'MsgYourSpawn'); //no "Respawning in X" message because you won't
			%this.centerPrint("\c5You have no lives left.",3);
			%this.bottomPrint("\c3Fire\c6 and \c3Jet\c6 to change camera position. \c3Jump\c6 to toggle camera mode.",10);
			
			%found = 0;
			for(%i=0;%i<%mini.numMembers;%i++)
			{
				%cl = %mini.member[%i];
				if(%cl.tdmLives > 0)
				{
					if(%found == 1)
					{
						if(%cl.tdmTeam != %foundTeam || %cl.tdmTeam == -1)
							return;
					}
					else
					{
						%found = 1;
						%foundTeam = %cl.tdmTeam;
						%foundClient = %cl;
					}
				}
			}
			
			if(!%mini.roundWon)
			{
				if(%found)
				{
					%mini.roundEnd(%foundTeam,0,%foundClient);
				}
				else
				{
					%mini.messageAll('',"\c5Everyone has died. Resetting in five seconds...");
					%mini.roundWon = 1;
					%mini.roundSwapTeams = 0;
					%mini.schedule(5000,reset,%mini.owner);
				}
			}
		}
	}
	
	function GameConnection::getAutoCameraTarget(%this)
	{
		if(!isObject(%this.minigame) || !isObject(%this.camera))
			return;
		
		%mini = %this.minigame;
		
		if(!%this.isSpectator())
			return;
		
		%mini = %this.minigame;
		%cam = %this.camera;
		for(%i=0;%i<%mini.numMembers;%i++)
		{
			%cl = %mini.member[%i];
			if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
			{
				%cam.setMode("Corpse",%cl.player);
				%this.tdmCameraTarget = %i;
				%this.setControlObject(%cam);
				return;
			}
		}
	}
	
	function GameConnection::isSpectator(%this)
	{	
		if(!isObject(%this.minigame) || !isObject(%this.camera))
			return;
		
		%mini = %this.minigame;
		
		if(%mini.roundWon)
			return 1;
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_canClientSpectate";
		if(isFunction(%f))
			%spec = call(%f,%mini,%this);
		else
			%spec = -1;
		
		if(%spec != -1)
			return %spec;
		
		if(%this.minigame.tdmLivesLimit <= 0 || %this.tdmLives > 0)
			return 0;
		
		return 1;
	}
	
	//Trader: Badspot sets the player items in this function, therefore I can
	//there's no other suitable function in between this and being spawned, Player::giveDefaultEquipment is only called outside of minigames
	function GameConnection::createPlayer(%this,%transform)
	{
		Parent::createPlayer(%this,%transform);
		
		if(!isObject(%this.player) || !isObject(%this.minigame))
			return;
		
		//set shape name distance to minigame setting
		%this.player.setShapeNameDistance(600);
		
		%mini = %this.minigame;
		if(%mini.tdmLivesLimit > 0)
		{
			%this.schedule(0,centerPrint,"\c5You have \c3" @ %this.tdmLives @ "\c5 " @ (%this.tdmLives == 1 ? "life" : "lives") @ " remaining.",2);
		}
		
		if(!gameModeAttribute(%mini.gamemode,"UsesTeams") || %this.tdmTeam == -1)
		{
			%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientSpawn";
			if(isFunction(%f))
				call(%f,%mini,%this);
			return;
		}
		
		%team = %this.tdmTeam;
		
		if(%mini.teamLeader[%team] == %this)
		{
			if(isObject(%mini.leadPlayerData[%team]))
				%data = %mini.leadPlayerData[%team];
			else
				%data = PlayerStandardArmor.getID();
			
			for(%i=0;%i<5;%i++)
			{
				if(isObject(%mini.leadStartEquip[%team,%i]))
					%se[%i] = %mini.leadStartEquip[%team,%i];
				else
					%se[%i] = 0;
			}
		}
		else
		{
			if(isObject(%mini.teamPlayerData[%team]))
				%data = %mini.teamPlayerData[%team];
			else
				%data = PlayerStandardArmor.getID();
			
			for(%i=0;%i<5;%i++)
			{
				if(isObject(%mini.teamStartEquip[%team,%i]))
					%se[%i] = %mini.teamStartEquip[%team,%i];
				else
					%se[%i] = 0;
			}
		}
		
		%this.player.setDatablock(%data);
		for(%i=0;%i<5;%i++)
		{
			%this.player.tool[%i] = %se[%i];
			messageClient(%this,'MsgItemPickup',"",%i,%se[%i],1);
		}
		
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_onClientSpawn";
		if(isFunction(%f))
			call(%f,%mini,%this);
	}
	
	function servercmdDropCameraAtPlayer(%client)
	{
		if((!%client.isAdmin && !%client.isSuperAdmin) || !isObject(%client.minigame) || %client.minigame.tdmLivesLimit == 0 || %client.tdmLives > 0)
			return Parent::servercmdDropCameraAtPlayer(%client);
		
		%client.centerPrint("\c5You have no lives left. Stop trying to cheat.",2);
	}
	
	function servercmdDropPlayerAtCamera(%client)
	{
		if((!%client.isAdmin && !%client.isSuperAdmin) || !isObject(%client.minigame) || %client.minigame.tdmLivesLimit == 0 || %client.tdmLives > 0)
			return Parent::servercmdDropPlayerAtCamera(%client);
		
		%client.centerPrint("\c5You have no lives left. Stop trying to cheat.",2);
	}
	
	function Observer::onTrigger(%this,%obj,%trigger,%state)
	{
		if(!isObject(%obj.getControllingClient()))
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		%client = %obj.getControllingClient();
		
		if(!isObject(%client.minigame))
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		%mini = %client.minigame;
		
		if(!%client.isSpectator())
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		//respawn you if you're spectating but dead and can respawn (possible use in game modes)
		if(!isObject(%client.player) && (%mini.tdmLivesLimit == 0 || %client.tdmLives > 0) && (getSimTime() > %client.deathTime + %mini.respawnTime))
			return Parent::onTrigger(%this,%obj,%trigger,%state); 
		
		if(%state == 0)
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		if(%mini.roundWon)
			return;
		
		%cam = %client.camera;
		
		switch(%trigger)
		{
			case 0:
				//Fire: Switch target forwards one
				cancel(%client.tdmCameraSched);
				for(%i=%client.tdmCameraTarget+1;%i<(%mini.numMembers+%client.tdmCameraTarget);%i++)
				{
					%cl = %mini.member[%i % %mini.numMembers];
					if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
					{
						%cam.setMode("Corpse",%cl.player);
						%client.tdmCameraTarget = %i;
						%client.setControlObject(%cam);
						return;
					}
				}
			case 2:
				//Jump: Switch camera mode
				cancel(%client.tdmCameraSched);
				if(%obj.mode $= "Observer" && isObject(%client.player))
				{
					%client.schedule(10,setControlObject,%client.player);
					%client.bottomPrint("\c3Jump\c6 to toggle \c3Spectator Mode\c7.",10);
					return;
				}
				else if(%obj.mode $= "Corpse")
				{
					%obj.setMode("Observer");
					%client.bottomPrint("\c3Jump\c6 to toggle camera mode.",10);
					return;
				}
				for(%i=%client.tdmCameraTarget+1;%i<(%mini.numMembers+%client.tdmCameraTarget);%i++)
				{
					%cl = %mini.member[%i % %mini.numMembers];
					if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
					{
						%cam.setMode("Corpse",%cl.player);
						%client.tdmCameraTarget = %i;
						%client.setControlObject(%cam);
						return;
					}
				}
			case 4:
				//Jet: Switch target backwards one
				cancel(%client.tdmCameraSched);
				for(%i=%mini.numMembers-%client.tdmCameraTarget;%i>-(%client.tdmCameraTarget);%i--)
				{
					%cl = %mini.member[(%i+%mini.numMembers) % %mini.numMembers];
					if(isObject(%cl.player) && %cl.player.getState() !$= "Dead")
					{
						%cam.setMode("Corpse",%cl.player);
						%client.tdmCameraTarget = %mini.numMembers-%i;
						%client.setControlObject(%cam);
						return;
					}
				}
		}
		
		return Parent::onTrigger(%this,%obj,%trigger,%state);
	}
	
	function Armor::onTrigger(%this,%obj,%trigger,%state)
	{
		if(!isObject(%obj.getControllingClient()))
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		%client = %obj.getControllingClient();
		
		if(!isObject(%client.minigame))
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		%mini = %client.minigame;
		
		if(!%client.isSpectator())
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		if(%mini.roundWon)
			return;
		
		if(%state == 0)
			return Parent::onTrigger(%this,%obj,%trigger,%state);
		
		if(%trigger == 2)
		{
			%client.schedule(10,getAutoCameraTarget);
			return;
		}
		
		return Parent::onTrigger(%this,%obj,%trigger,%state);
	}
	
	function GameConnection::applyBodyParts(%client)
	{
		//The Zombies script calls this for "gameconnection" even though the client is a player object...
		if(%client.getClassName() $= "GameConnection" || %client.getClassName() $= "AIConnection")
			return;
		else
			Parent::applyBodyParts(%client);
	}
	
	function GameConnection::applyBodyColors(%client)
	{
		//The Zombies script calls this for "gameconnection" even though the client is a player object...
		if(%client.getClassName() $= "GameConnection" || %client.getClassName() $= "AIConnection")
			%client.applyTeamUniform();
		else
			Parent::applyBodyColors(%client);
	}
	
	function GameConnection::applyTeamUniform(%client)
	{ 
		if(!isObject(%client.player) || !isObject(%client.minigame) || !gameModeAttribute(%client.minigame.gamemode,"UsesTeams") || %client.tdmTeam == -1)
		{
			Parent::applyBodyParts(%client);
			Parent::applyBodyColors(%client);
			return;
		}
		
		%player = %client.player;
		%mini = %client.minigame;
		%team = %client.tdmTeam;
		
		%val = "";
		%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_applyTeamUniform";
		if(isFunction(%f))
			%val = call(%f,%mini,%client);
		
		switch(%mini.uniMode)
		{
			case 0:
				//No change
				Parent::applyBodyParts(%client);
				Parent::applyBodyColors(%client);
			case 1:
				//Change shirt colour
				Parent::applyBodyParts(%client);
				Parent::applyBodyColors(%client);
				if(fileName(%player.getDatablock().shapeFile) !$= "m.dts")
				{
					%player.setNodeColor("ALL",fixAvatarColor(getColorIDTable(%mini.teamCol[%client.tdmTeam])));
					return;
				}
				%player.setNodeColor("chest",fixAvatarColor(getColorIDTable(%mini.teamCol[%team])));
				%player.setNodeColor("femchest",fixAvatarColor(getColorIDTable(%mini.teamCol[%team])));
			case 2:
				//Change accessories, but not face, hands or body shape
				if(fileName(%player.dataBlock.shapeFile) !$= "m.dts")
				{
					%player.setNodeColor("ALL",fixAvatarColor(getColorIDTable(%mini.teamCol[%client.tdmTeam])));
					return;
				}
				
				if(%mini.teamLeader[%team] == %client)
					%uni = %mini.leadUniform[%team];
				else
					%uni = %mini.teamUniform[%team]; 
				
				if(%val !$= "")
				{
					if(%val == 1)
						%uni = %mini.leadUniform[%team];
					else if(%val == 0)
						%uni = %mini.teamUniform[%team];
				}
				
				hideAllNodes(%player);
				
				if(isObject((%o = %player.getControlObject())) && %o.getDatablock().getName() $= "SkiVehicle")
				{
					%player.unHideNode("lski");
					%player.unHideNode("rski");
				}
				
				%player.unHideNode($chest[%client.chest]);
				%player.setNodeColor($chest[%client.chest],fixAvatarColor(getField(%uni,1)));
				
				%player.unHideNode($rArm[getField(%uni,2)]);
				%player.setNodeColor($rArm[getField(%uni,2)],fixAvatarColor(getField(%uni,3)));
				
				%player.unHideNode($lArm[getField(%uni,4)]);
				%player.setNodeColor($lArm[getField(%uni,4)],fixAvatarColor(getField(%uni,5)));
				
				%player.unHideNode($rHand[%client.rHand]);
				%player.setNodeColor($rHand[%client.rHand],fixAvatarColor(%client.rHandColor));
				
				%player.unHideNode($lHand[%client.lHand]);
				%player.setNodeColor($lHand[%client.lHand],fixAvatarColor(%client.lHandColor));
				
				%player.unhidenode($hip[getField(%uni,10)]);
				%player.setNodeColor($hip[getField(%uni,10)],fixAvatarColor(getField(%uni,11)));
				
				if(getField(%uni,10) == 0)
				{  
					%player.unhidenode($rLeg[getField(%uni,12)]);
					%player.setNodeColor($rLeg[getField(%uni,12)],fixAvatarColor(getField(%uni,13)));
					
					%player.unhidenode($lLeg[getField(%uni,14)]);
					%player.setNodeColor($lLeg[getField(%uni,14)],fixAvatarColor(getField(%uni,15)));
				}
				else
				{   
					%player.unhidenode("skirtTrimRight");%player.setNodeColor("skirtTrimRight",fixAvatarColor(getField(%uni,13)));
					%player.unhidenode("skirtTrimLeft");%player.setNodeColor("skirtTrimLeft",fixAvatarColor(getField(%uni,15)));
				}
				
				if(getField(%uni,16) != 0)
				{
					%player.unhidenode($hat[getField(%uni,16)]);
					%player.setNodeColor($hat[getField(%uni,16)],fixAvatarColor(getField(%uni,17)));
					if($accent[getField(%uni,18)] !$= "none")
					{
						%hat = $hat[getField(%uni,16)];
						if(%hat $= "helmet")
						{
							%player.unhidenode("visor");%player.setNodecolor("visor",fixAvatarColor(getField(%uni,19),1));
						}
						else if(%hat $= "scoutHat" || %hat $= "copHat" || %hat $= "knitHat")
						{
							%player.unhidenode($accent[getField(%uni,18)]);
							%player.setNodeColor($accent[getField(%uni,18)],fixAvatarColor(getField(%uni,19),1));
						}
					}
				}
				else if(%client.hat != 0)
				{
					%player.unhidenode($hat[%client.hat]);
					%player.setNodeColor($hat[%client.hat],fixAvatarColor(%client.hatColor));
					if($accent[%client.accent] !$= "none")
					{
						%hat = $hat[%client.hat];
						if(%hat $= "helmet")
						{
							%player.unhidenode("visor");%player.setNodecolor("visor",fixAvatarColor(%client.accentColor));
						}
						else if(%hat $= "scoutHat" || %hat $= "copHat" || %hat $= "knitHat")
						{
							%player.unhidenode($accent[%client.accent]);
							%player.setNodeColor($accent[%client.accent],fixAvatarColor(%client.accentColor));
						}
					}
				}
				
				%player.setHeadUp(0);
				
				if(getField(%uni,20) != 0)
				{
					%player.unhidenode($pack[getField(%uni,20)]);
					%player.setNodeColor($pack[getField(%uni,20)],fixAvatarColor(getField(%uni,21)));
					%player.setHeadUp(1);
					%player.setThreadDir(0,0);
				}
				
				if(getField(%uni,22) != 0)
				{
					%player.unhidenode($secondpack[getField(%uni,22)]);
					%player.setNodeColor($secondpack[getField(%uni,22)],fixAvatarColor(getField(%uni,23)));
					%player.setHeadUp(1);
					%player.setThreadDir(0,0);
				}
				
				%player.unHideNode("headskin");
				%player.setNodeColor("headskin",fixAvatarColor(%client.headColor));
				%player.setDecalName(fileBase(getField(%uni,25)));
				%player.setFaceName(fileBase(%client.faceName));
			case 3:
				//Apply entire uniform
				if(fileName(%player.dataBlock.shapeFile) !$= "m.dts")
				{
					%player.setNodeColor("ALL",getColorIDTable(%mini.teamCol[%client.tdmTeam]));
					return;
				}
				
				if(%mini.teamLeader[%team] == %client)
					%uni = %mini.leadUniform[%team];
				else
					%uni = %mini.teamUniform[%team];
				
				if(%val !$= "")
				{
					if(%val == 1)
						%uni = %mini.leadUniform[%team];
					else if(%val == 0)
						%uni = %mini.teamUniform[%team];
				}
				
				hideAllNodes(%player);
				
				if(isObject((%o = %player.getControlObject())) && %o.getDatablock().getName() $= "SkiVehicle")
				{
					%player.unHideNode("lski");
					%player.unHideNode("rski");
				}
				
				%player.unHideNode($chest[getField(%uni,0)]);
				%player.setNodeColor($chest[getField(%uni,0)],fixAvatarColor(getField(%uni,1)));
				
				%player.unHideNode($rArm[getField(%uni,2)]);
				%player.setNodeColor($rArm[getField(%uni,2)],fixAvatarColor(getField(%uni,3)));
				
				%player.unHideNode($lArm[getField(%uni,4)]);
				%player.setNodeColor($lArm[getField(%uni,4)],fixAvatarColor(getField(%uni,5)));
				
				%player.unHideNode($rHand[getField(%uni,6)]);
				%player.setNodeColor($rHand[getField(%uni,6)],fixAvatarColor(getField(%uni,7)));
				
				%player.unHideNode($lHand[getField(%uni,8)]);
				%player.setNodeColor($lHand[getField(%uni,8)],fixAvatarColor(getField(%uni,9)));
				
				%player.unhidenode($hip[getField(%uni,10)]);
				%player.setNodeColor($hip[getField(%uni,10)],fixAvatarColor(getField(%uni,11)));
				
				if(getField(%uni,10) == 0)
				{  
					%player.unhidenode($rLeg[getField(%uni,12)]);
					%player.setNodeColor($rLeg[getField(%uni,12)],fixAvatarColor(getField(%uni,13)));
					
					%player.unhidenode($lLeg[getField(%uni,14)]);
					%player.setNodeColor($lLeg[getField(%uni,14)],fixAvatarColor(getField(%uni,15)));
				}
				else
				{   
					%player.unhidenode("skirtTrimRight");%player.setNodeColor("skirtTrimRight",fixAvatarColor(getField(%uni,13)));
					%player.unhidenode("skirtTrimLeft");%player.setNodeColor("skirtTrimLeft",fixAvatarColor(getField(%uni,15)));
				}
				
				if(getField(%uni,16) != 0)
				{
					%player.unhidenode($hat[getField(%uni,16)]);
					%player.setNodeColor($hat[getField(%uni,16)],fixAvatarColor(getField(%uni,17)));
					if($accent[getField(%uni,18)] !$= "none")
					{
						%hat = $hat[getField(%uni,16)];
						if(%hat $= "helmet")
						{
							%player.unhidenode("visor");%player.setNodecolor("visor",fixAvatarColor(getField(%uni,19),1));
						}
						else if(%hat $= "scoutHat" || %hat $= "copHat" || %hat $= "knitHat")
						{
							%player.unhidenode($accent[getField(%uni,18)]);
							%player.setNodeColor($accent[getField(%uni,18)],fixAvatarColor(getField(%uni,19),1));
						}
					}
				}
				
				%player.setHeadUp(0);
				
				if(getField(%uni,20) != 0)
				{
					%player.unhidenode($pack[getField(%uni,20)]);
					%player.setNodeColor($pack[getField(%uni,20)],fixAvatarColor(getField(%uni,21)));
					%player.setHeadUp(1);
					%player.setThreadDir(0,0);
				}
				
				if(getField(%uni,22) != 0)
				{
					%player.unhidenode($secondpack[getField(%uni,22)]);
					%player.setNodeColor($secondpack[getField(%uni,22)],fixAvatarColor(getField(%uni,23)));
					%player.setHeadUp(1);
					%player.setThreadDir(0,0);
				}
				
				%player.unHideNode("headskin");
				%player.setNodeColor("headskin",fixAvatarColor(getField(%uni,24)));
				%player.setDecalName(fileBase(getField(%uni,25)));
				%player.setFaceName(fileBase(getField(%uni,26)));
		}
	}
	
	function ShapeBase::setShapeNameColor(%this,%c)
	{
		if(!%this.getType() & $TypeMasks::PlayerObjectType)
		{
			Parent::setShapeNameColor(%this,%c);
			return;
		}
		%client = %this.client;
		if(isObject(%client) && %client.player == %this && isObject(%client.minigame))
		{
			%mini = %client.minigame;
			%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_getShapeNameColor";
			if(isFunction(%f))
				%val = call(%f,%mini,%client,%this);
			
			if(%val !$= "")
				%c = %val;
			else if(gameModeAttribute(%mini.gamemode,"UsesTeams") && %client.tdmTeam != -1)
				%c = fixAvatarColor(getColorIDTable(%mini.teamCol[%client.tdmTeam]));
		}
		Parent::setShapeNameColor(%this,%c);
	}
	
	function ShapeBase::setShapeNameDistance(%this,%d)
	{
		if(!%this.getType() & $TypeMasks::PlayerObjectType)
		{
			Parent::setShapeNameDistance(%this,%d);
			return;
		}
		%client = %this.client;
		if(isObject(%client) && %client.player == %this && isObject(%client.minigame))
		{
			%mini = %client.minigame;
			%f = "GameMode_" @ gameModeAttribute(%mini.gamemode,"ShortTitle") @ "_getShapeNameDistance";
			if(isFunction(%f))
				%val = call(%f,%mini,%client,%this);
			
			if(%val !$= "")
				%d = %val;
			else if(%mini.tdmHideNames)
				%d = 16;
			else
				%d = 600;
		}
		Parent::setShapeNameDistance(%this,%d);
	}
	
	function disconnect()
	{
		Parent::disconnect();
		schedule(10, 0, deActivatePackage, TeamDeathmatch); //we probably don't want to de-activate a package while we're in it, so schedule it
		if(isObject(GameModeStorerSO))
			GameModeStorerSO.delete(); //Only delete it when you end the server, not when you change maps
	}
};activatePackage(TeamDeathmatch);

//Add the special extra rules
addGeneralRule("SHOWNAMES","Show Team-Colored Death CI","bool",0);
addGeneralRule("DEADTALK","Allow Dead Talking","bool",1);